/* COSPAT.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int cospat_(nap, theta, phi, bne, bnh, pol, etheta, ephi)
integer *nap;
real *theta, *phi, *bne, *bnh, *pol;
complex *etheta, *ephi;
{
    /* Initialized data */

    static real gcons = (float).1826374;
    static real sq2 = (float)1.4142135;

    /* System generated locals */
    real r__1, r__2;
    doublereal d__1, d__2, d__3, d__4;
    complex q__1, q__2, q__3;

    /* Builtin functions */
    double cos(), pow_dd(), sin(), sqrt();

    /* Local variables */
    static real de, ee, dh, ct, direct;


/*  Pattern approximation  I: E = cos(Theta/2)**N */
/*                        II: E = cos(Theta)**N */

/*  NAP      Pattern approximation number */
/*  THETA    Pattern angle (radians) */
/*  PHI      Pattern angle (radians) */
/*  BNE      Exponent in E plane */
/*  BNH      Exponent in H plane */
/*  POL      Polarization: 0 Linear, -1 RHC, +1 LHC */
/*  ETHETA   Theta component  V/m for 1 watt radiated power at 1 m. */
/*  EPHI     Phi component    V/m for 1 watt radiated power at 1 m. */

/* ------------------- GCONS = SQRT(4*PI/376.73) */
    de = *nap * (*nap * *bne + (float)1.);
    dh = *nap * (*nap * *bnh + (float)1.);
    direct = de * (float)2. * dh / (de + dh);
    ct = cos(*theta * *nap / (float)2.);
    if (ct <= (float)0.) {
	ee = (float)0.;
    } else {
/* ------------------- Elliptical beam approximation */
	d__1 = (doublereal) ct;
	d__2 = (doublereal) (*bne * (float)2.);
/* Computing 2nd power */
	r__1 = cos(*phi);
	d__3 = (doublereal) ct;
	d__4 = (doublereal) (*bnh * (float)2.);
/* Computing 2nd power */
	r__2 = sin(*phi);
	ee = sqrt(pow_dd(&d__1, &d__2) * (r__1 * r__1) + pow_dd(&d__3, &d__4) 
		* (r__2 * r__2));
    }
/* ------------------- Adjust to V/m for 1 w. Input at radius = 1 m. */
    ee = ee * sqrt(direct) / gcons;
    if (*pol == (float)0.) {
/* ------------------- Linear polarization, X-axis directed */
	r__1 = ee * cos(*phi);
	etheta->r = r__1, etheta->i = (float)0.;
	r__1 = -ee * sin(*phi);
	ephi->r = r__1, ephi->i = (float)0.;
    } else {
/* ------------------- Circular polarization, Phase = 0 at Phi = 0 */
	r__1 = cos(*phi);
	r__2 = *pol * sin(*phi);
	q__3.r = r__1, q__3.i = r__2;
	q__2.r = ee * q__3.r, q__2.i = ee * q__3.i;
	q__1.r = q__2.r / sq2, q__1.i = q__2.i / sq2;
	etheta->r = q__1.r, etheta->i = q__1.i;
	q__2.r = (float)0., q__2.i = *pol;
	q__1.r = q__2.r * etheta->r - q__2.i * etheta->i, q__1.i = q__2.r * 
		etheta->i + q__2.i * etheta->r;
	ephi->r = q__1.r, ephi->i = q__1.i;
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* cospat_ */

