/* POLYIN.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

doublereal polyin_(pt, vt, nv, an)
real *pt, *vt;
integer *nv;
real *an;
{
    /* Initialized data */

    static real pi = (float)3.141592654;

    /* System generated locals */
    integer i__1;
    real ret_val;

    /* Builtin functions */
    double atan2();

    /* Local variables */
    static real thmt;
    static integer i__, j, k;
    extern /* Subroutine */ int cross_();
    static real v1[3], v2[3];
    static integer kk;
    static real xx[3];
    extern doublereal dot_();


/*  Whether point PT, an intersection with the planar polygon, is */
/*  inside (+1) or outside (-1) the polygon */

/*  PT(3)     Intersection point with plane */
/*  VT(3,NT)  Vertices of the polygon ordered CCW around Normal */
/*  NV        Number of vertices */
/*  AN(3)     Plane unit normal */

    /* Parameter adjustments */
    --an;
    --vt;
    --pt;

    /* Function Body */
    ret_val = (float)1.;
    thmt = (float)0.;
    i__1 = *nv - 1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	k = (i__ - 1) * 3;
	kk = i__ * 3;
	for (j = 1; j <= 3; ++j) {
	    v1[j - 1] = vt[k + j] - pt[j];
/* L1: */
	    v2[j - 1] = vt[kk + j] - pt[j];
	}
	cross_(v1, v2, xx);
/* L2: */
	thmt += atan2(dot_(xx, &an[1]), dot_(v1, v2));
    }
    k = (*nv - 1) * 3;
    for (j = 1; j <= 3; ++j) {
	v1[j - 1] = vt[k + j] - pt[j];
/* L3: */
	v2[j - 1] = vt[j] - pt[j];
    }
    cross_(v1, v2, xx);
    thmt += atan2(dot_(xx, &an[1]), dot_(v1, v2));
    if (dabs(thmt) < pi) {
	ret_val = (float)-1.;
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return ret_val;
} /* polyin_ */

