/* RCSPAT.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int rcspat_(rot, nap, theta, phi, bne, bnh, pol, etheta, 
	ephi)
real *rot;
integer *nap;
real *theta, *phi, *bne, *bnh, *pol;
complex *etheta, *ephi;
{
    /* System generated locals */
    real r__1, r__2;
    complex q__1, q__2, q__3;

    /* Local variables */
    static complex ephe;
    static real thete;
    extern /* Subroutine */ int ffdirc_();
    static real vp[3], vr[3], vt[3];
    static complex ethete;
    extern /* Subroutine */ int cospat_(), patrot_();
    static real phe;
    extern doublereal dot_();
    static real vpp[3], vpr[3], vtp[3], vrr[3], vtr[3];


/*  Rotated */
/*  Pattern approximation  I: E = cos(Theta/2)**N */
/*                        II: E = cos(Theta)**N */

/*  ROT(3,3) Rotation matrix */
/*  NAP      Pattern approximation number */
/*  THETA    Pattern angle (radians) */
/*  PHI      Pattern angle (radians) */
/*  BNE      Exponent in E plane */
/*  BNH      Exponent in H plane */
/*  POL      Polarization: 0 Linear, -1 RHC, +1 LHC */
/*  ETHETA   Theta component  V/m for 1 watt radiated power at 1 m. */
/*  EPHI     Phi component    V/m for 1 watt radiated power at 1 m. */

/* ------------ Find unit vectors for pattern direction */
    /* Parameter adjustments */
    rot -= 4;

    /* Function Body */
    ffdirc_(theta, phi, vr, vt, vp);
/* ------------ Express VR in element coordinates for pattern */
/*              directions & Express VT and VP in element coordinates */
    patrot_(&rot[4], vr, vt, vp, &thete, &phe, vtp, vpp);
/* ------------ Find pattern */
    cospat_(nap, &thete, &phe, bne, bnh, pol, &ethete, &ephe);
/* ------------ Find unit vectors in element coordinate system */
    ffdirc_(&thete, &phe, vrr, vtr, vpr);
/* ------------ Project element components onto re-expressed */
/*              unit vectors to find components */
    r__1 = dot_(vtr, vtp);
    q__2.r = r__1 * ethete.r, q__2.i = r__1 * ethete.i;
    r__2 = dot_(vpr, vtp);
    q__3.r = r__2 * ephe.r, q__3.i = r__2 * ephe.i;
    q__1.r = q__2.r + q__3.r, q__1.i = q__2.i + q__3.i;
    etheta->r = q__1.r, etheta->i = q__1.i;
    r__1 = dot_(vtr, vpp);
    q__2.r = r__1 * ethete.r, q__2.i = r__1 * ethete.i;
    r__2 = dot_(vpr, vpp);
    q__3.r = r__2 * ephe.r, q__3.i = r__2 * ephe.i;
    q__1.r = q__2.r + q__3.r, q__1.i = q__2.i + q__3.i;
    ephi->r = q__1.r, ephi->i = q__1.i;
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* rcspat_ */

