/* SUBGEO.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static doublereal c_b4 = -1.;
static real c_b5 = (float)1.;
static integer c__1 = 1;

/* Subroutine */ int subgeo_(dia, a, b, offset, type__, vp, alinc, lunit)
real *dia, *a, *b, *offset, *type__, *vp, *alinc;
integer *lunit;
{
    /* Initialized data */

    static real pi = (float)3.14159654;

    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2;
    doublereal d__1;

    /* Builtin functions */
    double cos(), sin(), sqrt(), pow_dd();
    integer s_wdue(), do_uio(), e_wdue();

    /* Local variables */
    static real area, frec[19];
    static integer krec, ibuf[19], i__, j;
    extern /* Subroutine */ int ellnm_(), vlinc_(), hypnm_();
    static real r1, r2, hp, hr, ph;
    static integer nn, np;
    static real pp[3];
    static integer nr;
    static real rp, rad;

    /* Fortran I/O blocks */
    static cilist io___17 = { 0, 0, 0, 0, 0 };
    static cilist io___20 = { 0, 0, 0, 0, 1 };



/*  Offset Subreflector Geometry for Currents File */
/*  Polar Grid */

/*  DIA     Diameter of projected reflector */
/*  A       Denominator factor of Z */
/*  B       Denominator factor of X & Y */
/*  OFFSET  Offset (center of circular aperture in X-Y plane) */
/*  TYPE    1) Hyperboloid (Cassegrain)  2) Ellipsoid (Gregorian) */
/*  VP(3)   Location of hyperboloid (ellipsoid) center */

/*  Note:   Hyperboloid (ellipsoid) axis along Z-axis */
/*          and located on positive Z-axis */
/*  ALINC   Current patch increment */
/*  LUNIT   Logical unit of random access file for currents */

    /* Parameter adjustments */
    --vp;
    --offset;

    /* Function Body */
    nr = *dia / *alinc / (float)2. + (float).5;
    hr = *dia / (float)2. / nr;
    krec = 1;
/*  ------------- Loop over radius */
    i__1 = nr;
    for (j = 1; j <= i__1; ++j) {
	rad = ((real) (j - 1) + (float).5) * hr;
/*  ------------- Find differential area on aperture plane */
	r1 = rad - hr / (float)2.;
	r2 = rad + hr / (float)2.;
/* Computing 2nd power */
	r__1 = r2;
/* Computing 2nd power */
	r__2 = r1;
	area = (r__1 * r__1 - r__2 * r__2) / (float)2.;
	np = pi * (float)2. * rad / *alinc + (float).5;
	np /= 4;
	np = np + 1 << 2;
	hp = pi * (float)2. / np;
/*  ------------- Loop over Phi */
	i__2 = np;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    ph = (real) (i__ - 1) * hp;
	    pp[0] = offset[1] + rad * cos(ph);
	    pp[1] = offset[2] + rad * sin(ph);
/* Computing 2nd power */
	    r__1 = pp[0];
/* Computing 2nd power */
	    r__2 = pp[1];
	    rp = sqrt(r__1 * r__1 + r__2 * r__2);
/* Computing 2nd power */
	    r__1 = rp / *b;
	    d__1 = (doublereal) (*type__);
	    pp[2] = *a * sqrt((float)1. - r__1 * r__1 * pow_dd(&c_b4, &d__1));
/*  ------------- Find unit normal */
	    if (*type__ == (float)1.) {
		hypnm_(pp, a, b, &frec[4]);
	    }
	    if (*type__ == (float)2.) {
		ellnm_(pp, a, b, &frec[4]);
	    }
/*  ------------- Adjust area */
	    frec[3] = area * hp / dabs(frec[6]);
	    vlinc_(&c_b5, &vp[1], &c_b5, pp, frec);
	    ++krec;
/* L1: */
	    io___17.ciunit = *lunit;
	    io___17.cirec = krec;
	    s_wdue(&io___17);
	    for (nn = 1; nn <= 19; ++nn) {
		do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	    }
	    e_wdue();
	}
/* L2: */
    }
    ibuf[0] = krec - 1;
    ibuf[1] = 1;
    io___20.ciunit = *lunit;
    s_wdue(&io___20);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
    return 0;
} /* subgeo_ */

/* Subroutine */ int hypnm_(po, a, b, an)
real *po, *a, *b, *an;
{
    /* System generated locals */
    real r__1;

    /* Builtin functions */
    double sqrt();

    /* Local variables */
    static real den;


/*  Normal of Hyperboloid */

/*  Hyperboloid coordinates for centered figure */
/*  PO  Position on Hyperboloid */
/*  A   Denominator factor of Z */
/*  B   Denominator factor of X & Y */
/*  AN  Normalized Normal Vector */

/*  The Hyperboloid is axisymmetric about Z axis */

    /* Parameter adjustments */
    --an;
    --po;

    /* Function Body */
/* Computing 2nd power */
    r__1 = po[3] * *b * *b / (*a * *a);
    den = sqrt(po[1] * po[1] + po[2] * po[2] + r__1 * r__1);
    an[1] = po[1] / den;
    an[2] = po[2] / den;
/* Computing 2nd power */
    r__1 = *b / *a;
    an[3] = -po[3] * (r__1 * r__1) / den;
    return 0;
} /* hypnm_ */

/* Subroutine */ int ellnm_(po, a, b, an)
real *po, *a, *b, *an;
{
    /* System generated locals */
    real r__1;

    /* Builtin functions */
    double sqrt();

    /* Local variables */
    static real den;


/*  Inward Normal of Ellipsoid */

/*  Ellipsoid coordinates for centered figure */
/*  PO  Position on Ellipsoid */
/*  A   Denominator factor of Z */
/*  B   Denominator factor of X & Y */
/*  AN  Normalized Normal Vector */

/*  The Ellipsoid is axisymmetric about Z axis */

    /* Parameter adjustments */
    --an;
    --po;

    /* Function Body */
/* Computing 2nd power */
    r__1 = po[3] * *b * *b / (*a * *a);
    den = sqrt(po[1] * po[1] + po[2] * po[2] + r__1 * r__1);
    an[1] = -po[1] / den;
    an[2] = -po[2] / den;
/* Computing 2nd power */
    r__1 = *b / *a;
    an[3] = -po[3] * (r__1 * r__1) / den;
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* ellnm_ */

