/* VGRHJF.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int vgrhjf_(vr, vt, vp, xs, pk, cur, htheta, hphi)
real *vr, *vt, *vp, *xs, *pk;
complex *cur, *htheta, *hphi;
{
    /* Initialized data */

    static real fpi = (float)12.5663706;

    /* System generated locals */
    real r__1, r__2;
    complex q__1, q__2, q__3, q__4, q__5, q__6, q__7;

    /* Builtin functions */
    double cos(), sin();

    /* Local variables */
    static complex conp;
    static real phase;
    extern doublereal dot_();


/*  Far field Vector Green's Function */

/*  Vector Green's function between source current density: J */
/*  and magnetic field: H  or */
/*  Vector Green's function between source current magnetic density: M */
/*  and the electric field: E when multiplied by -1 */

/*  VR(3)    Radial unit vector */
/*  VT(3)    Theta directed unit vector */
/*  VP(3)    Phi directed unit vector */
/*  XS(3)    Position of current element */
/*  PK       Propagation constant = 2*Pi/wavelength */
/*  CUR(3)   Rectangular coordinates of current density (complex) */

/*  HTHETA   Theta component of magnetic (electric) field */
/*  HPHI     Phi component of magnetic (electric) field */

    /* Parameter adjustments */
    --cur;
    --xs;
    --vp;
    --vt;
    --vr;

    /* Function Body */
    phase = *pk * dot_(&xs[1], &vr[1]);
    q__4.r = (float)0., q__4.i = *pk;
    q__3.r = -q__4.r, q__3.i = -q__4.i;
    r__1 = cos(phase);
    r__2 = sin(phase);
    q__5.r = r__1, q__5.i = r__2;
    q__2.r = q__3.r * q__5.r - q__3.i * q__5.i, q__2.i = q__3.r * q__5.i + 
	    q__3.i * q__5.r;
    q__1.r = q__2.r / fpi, q__1.i = q__2.i / fpi;
    conp.r = q__1.r, conp.i = q__1.i;
/* ---------------- Field components from currents */
    q__4.r = vp[1] * cur[1].r, q__4.i = vp[1] * cur[1].i;
    q__5.r = vp[2] * cur[2].r, q__5.i = vp[2] * cur[2].i;
    q__3.r = q__4.r + q__5.r, q__3.i = q__4.i + q__5.i;
    q__6.r = vp[3] * cur[3].r, q__6.i = vp[3] * cur[3].i;
    q__2.r = q__3.r + q__6.r, q__2.i = q__3.i + q__6.i;
    q__1.r = q__2.r * conp.r - q__2.i * conp.i, q__1.i = q__2.r * conp.i + 
	    q__2.i * conp.r;
    htheta->r = q__1.r, htheta->i = q__1.i;
    q__5.r = vt[1] * cur[1].r, q__5.i = vt[1] * cur[1].i;
    q__6.r = vt[2] * cur[2].r, q__6.i = vt[2] * cur[2].i;
    q__4.r = q__5.r + q__6.r, q__4.i = q__5.i + q__6.i;
    q__7.r = vt[3] * cur[3].r, q__7.i = vt[3] * cur[3].i;
    q__3.r = q__4.r + q__7.r, q__3.i = q__4.i + q__7.i;
    q__2.r = -q__3.r, q__2.i = -q__3.i;
    q__1.r = q__2.r * conp.r - q__2.i * conp.i, q__1.i = q__2.r * conp.i + 
	    q__2.i * conp.r;
    hphi->r = q__1.r, hphi->i = q__1.i;
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* vgrhjf_ */

