/* VSLCUR.F -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static real c_b7 = (float)1.;
static real c_b8 = (float)-1.;

/* Subroutine */ int vslcur_(freq, fd, al, uu, ul, nptt, curr, lunit)
real *freq, *fd, *al, *uu, *ul;
integer *nptt;
real *curr;
integer *lunit;
{
    /* Initialized data */

    static real cc = (float).2997925;
    static real pi = (float)3.141592654;

    /* System generated locals */
    integer i__1, i__2;
    real r__1;
    static real equiv_0[19];
    static complex equiv_1[10];

    /* Builtin functions */
    integer s_wdue(), do_uio(), e_wdue();
    double sin(), pow_ri();

    /* Local variables */
#define frec ((real *)equiv_1)
    static integer krec;
#define ibuf ((integer *)equiv_0)
    static real curc;
#define curm ((complex *)((integer *)equiv_1 + 13))
    static integer npts, i__, j, k;
    static real t, u[3];
    extern /* Subroutine */ int vlinc_();
    static real wavel, ai;
#define pk (equiv_0 + 2)
    static integer nn;
    static real cur;

    /* Fortran I/O blocks */
    static cilist io___9 = { 0, 0, 0, 0, 1 };
    static cilist io___20 = { 0, 0, 0, 0, 0 };



/*  Currents file for Vee Slot (built in Simpson's rule integration) */

/*  FREQ    Frequency (GHz) */
/*  FD(3)   Feed point (m) */
/*  AL	   Length of slot (sum of both arms) (m) */
/*  UU(3)   Direction of unit vector of upper arm */
/*  UL(3)   Direction of unit vector of lower arm */
/*  NPTT    Number of points along each arm */
/*  CURR    Multiplier on current magnitude (for mutual = 1) */
/*  LUNIT   Logical unit of file for currents */

    /* Parameter adjustments */
    --ul;
    --uu;
    --fd;

    /* Function Body */
    wavel = cc / *freq;
    *pk = pi * (float)2. / wavel;
/* --------- Round points up to odd for Simpson's rule */
    npts = *nptt;
    if (npts % 2 == 0) {
	++npts;
    }
    ibuf[0] = npts << 1;
    ibuf[1] = 2;
    io___9.ciunit = *lunit;
    s_wdue(&io___9);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
    krec = 1;
    ai = *al / ((npts - 1) * (float)2.);
    curc = *curr / (float)3.;
/* ---------- Loop on arms */
    for (k = 1; k <= 2; ++k) {
	for (i__ = 1; i__ <= 3; ++i__) {
	    if (k == 1) {
		u[i__ - 1] = uu[i__];
	    }
	    if (k == 2) {
		u[i__ - 1] = ul[i__];
	    }
/* L1: */
	}
/* ---------- Loop on points along slot */
	i__1 = npts;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    t = (i__ - 1) * ai;
	    vlinc_(&c_b7, &fd[1], &t, u, frec);
	    cur = -sin(*pk * (*al / (float)2. - t)) * curc * ai * pow_ri(&
		    c_b8, &k);
/* ---------- Simpson's rule weights */
	    if (i__ > 1 && i__ < npts) {
		if ((i__ - 1) % 2 == 1) {
		    cur *= (float)4.;
		}
		if ((i__ - 1) % 2 == 0) {
		    cur *= (float)2.;
		}
	    }
/* ---------- Normal currents including Simpson's weights */
	    for (j = 1; j <= 3; ++j) {
/* L2: */
		i__2 = j - 1;
		r__1 = u[j - 1] * cur;
		curm[i__2].r = r__1, curm[i__2].i = (float)0.;
	    }
	    ++krec;
/* L3: */
	    io___20.ciunit = *lunit;
	    io___20.cirec = krec;
	    s_wdue(&io___20);
	    for (nn = 1; nn <= 19; ++nn) {
		do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	    }
	    e_wdue();
	}
/* L4: */
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* vslcur_ */

#undef pk
#undef curm
#undef ibuf
#undef frec


