      PROGRAM CCPSPC
C
C  Mutual Coupling between Square Patches at resonance using Dyadic
C  Green's Function approach
C
C  Written   16 Jul 94
C  Last Edit 16 Jul 94
C
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
C
      DIMENSION DIST(301),COUP(301),YR(301),YI(301)
      COMPLEX Z(4),ZS,ZL,ZIN,SCUTAL,CURJA,CURMA
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,2000)
      COMMON /CURRENJ/CURJA(3,2000)
      COMMON /CURRENM/CURMA(3,2000)
      DATA TR/.01745329/,C/29.97925/
      WRITE(6,1)
    1 FORMAT(' Mutual coupling between identical square patches',/,
     1' Enter Resonant length (cm) ',$)
      READ(5,*)RL
      WIDTH=RL*.01
      WRITE(6,3)
    3 FORMAT(' Enter frequency (GHz) ',$)
      READ(5,*)FREQ
      WAVE=C/FREQ
      Z(1)=RRADCN(RL/WAVE)
      Z(4)=Z(1)
      ZS=Z(1)
      ZL=Z(1)
      OPEN(66,FILE='ccpspc.out')
      OPEN(19,FILE='ccpspc.dat',ACCESS='DIRECT',RECL=76)
      WRITE(66,5)RL,FREQ
    5 FORMAT(' Mutual coupling between identical square patches',/,
     1' Resonant Length:          ',F8.4,/,
     4' Frequency (GHz):          ',F8.4)
    6 WRITE(6,7)
    7 FORMAT(' E plane along X axis',/,' Enter Phi ',$)
      READ(5,*)PHI
      WRITE(6,20)
   20 FORMAT(' Enter polarization: 0 linear, -1 RHC, +1 LHC ',$)
      READ(5,*)POL
      WRITE(6,4)
    4 FORMAT(' Enter points in edge integrals (101 max) ',$)
      READ(5,*)NINT
      IF(NINT.GT.101)STOP
      CALL SPACUR(WIDTH,FREQ,POL,NINT,19)
      CALL CURCOM(19)
      WRITE(6,8)
    8 FORMAT(' Enter Center Separation Start,Stop,Step ',$)
      READ(5,*)R1,R2,R3
      IF(R3.EQ.0.)STOP
      NR=(R2-R1)/R3+1.3
      WRITE(6,9)
    9 FORMAT(' Center Separation: 1 cm., 2 wavelengths ',$)
      READ(5,*)IRR
      WRITE(6,10)
   10 FORMAT(' List? ',$)
      LIST=NYES(K)
      IF(LIST.EQ.1)WRITE(66,21)POL,NINT
   21 FORMAT(' Polarization (0 linear, -1 RHC, 1 LHC): ',F5.0,/,
     1' Points in integrals along edges: ',I4)
      IF(LIST.EQ.1.AND.IRR.EQ.1)THEN
      WRITE(6,11)PHI
      WRITE(66,11)PHI
   11 FORMAT(' Angle of Radial Line = ',F7.2,/,
     1 ' Distances in cm.',/,
     2'   Radius   Coupling dB    Normalized admittance')
      ENDIF
      IF(LIST.EQ.1.AND.IRR.EQ.2)THEN
      WRITE(6,12)PHI
      WRITE(66,12)PHI
   12 FORMAT(' Angle of Radial Line = ',F7.2,/,
     1 ' Distances in wavelengths',/,
     2'   Radius   Coupling dB    Normalized admittance')
      ENDIF
   13 FORMAT(F9.3,F11.3,1PE14.3,E14.3)
      DO14I=1,NR
      DIST(I)=R1+FLOAT(I-1)*R3
      RR=DIST(I)
      IF(IRR.EQ.2)RR=RR*WAVE
      X=RR*COS(PHI*TR)
      Y=RR*SIN(PHI*TR)
      Z(2)=SCUTAL(RL,RL,FREQ,X,Y,NINT,POL)
      YR(I)=REAL(Z(2)/Z(1))
      YI(I)=AIMAG(Z(2)/Z(1))
      Z(3)=Z(2)
      CALL YRES(Z,ZS,ZL,R,RA,T,TA,ZIN)
      COUP(I)=T
      IF(LIST.EQ.1)THEN
      WRITE(66,13)DIST(I),COUP(I),YR(I),YI(I)
      WRITE(6,13)DIST(I),COUP(I),YR(I),YI(I)
      ENDIF
   14 CONTINUE
      WRITE(6,15)
   15 FORMAT(' Any plots? ',$)
      IF(NYES(K).EQ.1)THEN
      WRITE(6,16)
   16 FORMAT(' Plot coupling? ',$)
      IF(NYES(K).EQ.1)CALL RCPLT(DIST,COUP,NR)
      WRITE(6,17)
   17 FORMAT(' Plot real part of normalized admittance? ',$)
      IF(NYES(K).EQ.1)CALL RCPLT(DIST,YR,NR)
      WRITE(6,18)
   18 FORMAT(' Plot imaginary part of normalized admittance? ',$)
      IF(NYES(K).EQ.1)CALL RCPLT(DIST,YI,NR)
      ENDIF
      GOTO6
      END
      SUBROUTINE YRES(Y,YS,YL,R,RA,T,TA,YIN)
C 
C  RESPONSE OF Y MATRIX (2 PORT)
C 
C  Y MATRIX, YS SOURCE ADMITTANCE, YL LOAD ADMITTANCE,
C  R INPUT RELECTION COEFFICIENT MAGNITUDE, RA ANGLE
C  T TRANSMISSION DB, TH ANGLE, YIN INPUT ADMITTANCE
C 
      COMPLEX Y(4),YS,YL,YIN,B1 
      YIN=Y(1)-Y(2)*Y(3)/(YL+Y(4))
      B1=(YS-YIN)/(YS+YIN)
      R=CABS(B1)
      RA=57.29578*ATAN2(AIMAG(B1),REAL(B1)) 
      B1=-Y(3)*YS/((YS+Y(1))*(YL+Y(4))-Y(2)*Y(3)) 
      TA=57.29578*ATAN2(AIMAG(B1),REAL(B1)) 
      T=4.342945*ALOG(4.*REAL(YS)*REAL(YL)*CABS(B1/YS)**2)
      RETURN
      END 
