      COMPLEX FUNCTION CCUTAL(R1,R2,F,X,Y,NINT,POL)
C
C  Mutual admittance between two circular patch antennas
C  using currents in common for first patch
C
C  R1      Radius of 1st patch (cm)
C  R2      Radius of 2nd patch (cm)
C  F       Frequency (GHz)
C  X,Y	   Position of 2nd patch (cm)
C  NINT    Number of points in integrals
C  POL	   Polarization: 0 Linear, -1 RHC, +1 LHC
C
C  Note:   Feeds located on X axis
C
      COMPLEX CCDOT,EFIELD(3),HFIELD(3),AM(3),SS
      DIMENSION XF(3),XC(3),XB(1)
      EXTERNAL BLOCKN
      DATA CC/.2997925/,PI/3.14159265/,XC/0.,0.,0./
      RAD1=R1*.01
      RAD2=R2*.01
      WAVEL=CC/F
      HP=2.*PI*RAD2/(NINT-1)
      V1=SQRT(1./CRADCN(RAD1/WAVEL))
      SS=0.
C ------------------- Find reaction along edge
      DO 1 I=1,NINT
      POS=HP*(I-1)
      CALL CPPERM(POS,RAD2,XF,AM,POL)
      XF(1)=XF(1)+X*.01
      XF(2)=XF(2)+Y*.01
C ------------------- Find fields at point due to 1st patch
      CALL NFPATR(XC,BLOCKN,XB,XF,EFIELD,HFIELD)
C ------------------- Find reaction at point
    1 SS=CCDOT(HFIELD,AM)*HP+SS
C ------------------- Half space radiation, reduce by 1/2
      CCUTAL=-SS/V1/2.
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
