      SUBROUTINE CONEGEO(P1,P2,RAD1,RAD2,ALINC,LUNIT,ICAT)
C
C  Geometry file of Truncated Cone
C
C  P1(3)      Starting point of cone (m)
C  P2(3)      End point of axis  (m)
C  RAD1       Radius of cone at point P1
C  RAD2       Radius of cone at point P2
C  ALINC      Current patch increment (m)
C  LUNIT      Logical unit of disk file
C  ICAT       If 1, concatenate
C
      DIMENSION P1(3),P2(3),AXIS(3),SP(3),FREC(19),ROT(3,3),EU(3),
     1 IA(3),POS(3),VEC(3)
      INTEGER*4 IBUF(19)
      DATA PI/3.141592654/,IA/3,2,3/
      CALL VLINC(1.,P2,-1.,P1,AXIS)
      CALL RETSP(AXIS,SP)
      ANGLE=ATAN((RAD2-RAD1)/SP(1))
C  ------------ Find axis increment: ALEN
      NL=SP(1)/ALINC/COS(ANGLE)+.5
      ALEN=SP(1)/NL
C  ------------ Find rotation matrix
      EU(1)=SP(3)
      EU(2)=SP(2)
      EU(3)=0.
      CALL EULER(EU,IA,ROT)
C  ------------ Layout cone along Z-axis
      IF(ICAT.EQ.1)THEN
      READ(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      KREC=IBUF(1)+1
      ELSE
      KREC=1
      ENDIF
      DO 2 I=1,NL
      POS(3)=(I-.5)*ALEN
      Z2=I*ALEN
      Z1=(I-1)*ALEN
      RADIUS=RAD1+POS(3)*(RAD2-RAD1)/SP(1)
      NP=2.*PI*RADIUS/ALINC+.5
      NP=NP/4
      NP=(NP+1)*4
      AINC=2.*PI/NP
C  ------------ Find patch area
      FREC(4)=AINC*(RAD1*ALEN+(Z2**2-Z1**2)*0.5*TAN(ANGLE))/
     1 COS(ANGLE)
      DO 1 J=1,NP
      ANG=(J-1)*AINC
C  ------------ Find position
      POS(1)=RADIUS*COS(ANG)
      POS(2)=RADIUS*SIN(ANG)
      CALL MTMULT(POS,ROT,VEC,1,3,3)
      CALL VLINC(1.,VEC,1.,P1,FREC)
C  ------------ Find normal vector
      VEC(1)=COS(ANG)*COS(ANGLE)
      VEC(2)=SIN(ANG)*COS(ANGLE)
      VEC(3)=-SIN(ANGLE)
      CALL MTMULT(VEC,ROT,FREC(5),1,3,3)
      KREC=KREC+1
    1 WRITE(LUNIT,REC=KREC)(FREC(NN),NN=1,19)
    2 CONTINUE
      IBUF(1)=KREC-1
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
