      SUBROUTINE CPPERM(P,RAD,POS,AM,POL)
C
C  Perimeter function of circular patch
C
C  P   Perimeter value (0 starts on X axis)
C  RAD Radius
C  POS    Position on patch centered on origin
C  AM(3)  Normalized magnetic current direction
C  POL	  Polarization: 0 Linear, -1 RHC, +1 LHC
C
      DIMENSION POS(3)
      COMPLEX AM(3)
      DATA S2/1.1421356/
      PH=P/RAD
      POS(3)=0.
      AM(3)=0.
      AM(1)=-SIN(PH)*COS(PH)
      AM(2)=COS(PH)*COS(PH)
      IF(POL.NE.0.)THEN
      AM(1)=(AM(1)-CMPLX(0.,POL)*SIN(PH)*SIN(PH))/S2
      AM(2)=(AM(2)+CMPLX(0.,POL)*COS(PH)*SIN(PH))/S2
      ENDIF
      POS(1)=COS(PH)*RAD
      POS(2)=SIN(PH)*RAD
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
