      SUBROUTINE CURCOM(LUNIT)
C
C  Read currents from file into CURRENT common
C
C  LUNIT    Logical unit of random access file (open file)
C
C  File:  76 Bytes record
C
C  Record 1
C
C  Number of records
C  Types of currents available: 0 both, 1 electric only, 2 magnetic only
C  Propagation constant (1./meters)
C
C  Record 2 - NCUR+1
C
C  Position(3)   meters
C  Area          meters**2
C  Normal(3)     Unit normal to patch
C  J(3)          Electric current * area
C  M(3)          Magnetic current * area
C
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,2000)
      COMMON /CURRENJ/CURJA(3,2000)
      COMMON /CURRENM/CURMA(3,2000)
C
C  CURRENT Common
C
C  NCUR     Number of points
C  NCTYP    Current types: 0 both, 1 electric only, 2 magnetic only
C  PKC      Propagation constant (1./meters)
C  POSC     Position of current element (meters)
C  CURJA    Electric current * area rectangular components (complex)
C  CURMA    Magnetic current * area rectangular components (complex)
C
      COMPLEX CURJA,CURMA,CURJ(3),CURM(3)
      DIMENSION FREC(19)
      INTEGER*4 IBUF(19)
      EQUIVALENCE (IBUF(3),PK),(FREC(8),CURJ(1)),(FREC(14),CURM(1))
      READ(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      NCUR=IBUF(1)
      NCTYP=IBUF(2)
      PKC=PK
      DO 2 I=1,NCUR
      READ(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
      DO 1 J=1,3
      POSC(J,I)=FREC(J)
      CURJA(J,I)=CURJ(J)
    1 CURMA(J,I)=CURM(J)
    2 CONTINUE
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
