      PROGRAM DURPAT
C
C  PO analysis of Dual Circular Aperture Paraboloidal Reflector
C
C  Written   24 Sep 95
C  Last Edit 24 Jan 96
C
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
C
      DIMENSION THT(501),AEI(501),VR(3),VT(3),VP(3),XF(3),
     1 XC(3),XFD(3),UF(4),EU(3),IA(3),OFFS(2),CB(3),ROTD(3,3)
     1 ,XB(35),ROT(3,3),FEED(3),EUA(3),
     1 IUA(3),ZXX(3),XXR(3),OB(3)
      COMPLEX EITH(501),EIPH(501),EII,EFIELD(3),HFIELD(3),
     1 CURJA,CURMA,ETHETA,EPHI,PHAA
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,4000)
      COMMON /CURRENJ/CURJA(3,4000)
      COMMON /CURRENM/CURMA(3,4000)
      CHARACTER UN(4)*4,FILOUT*40
      EXTERNAL BLOCKN
      DATA TR/.01745329/,IC/0/,GCONS/.182637/,XC/0.,0.,0./,
     1 PI/3.141592654/,CC/.2997925/,ZXX/0.,0.,1./
     1,UN/' in.',' ft.',' cm ',' m. '/,UF/.0254,.3048,.01,1./
      LU=66
      WRITE(6,1)
    1 FORMAT(' PO analysis of Dual Paraboloidal Reflector',
     3/,' Enter diameter, focal length ',$)
      READ(5,*)DIA,FOCAL
      FOD=FOCAL/DIA
      WRITE(6,2)
    2 FORMAT(' Enter units: 1 in., 2 ft., 3 cm, 4 m ',$)
      READ(5,*)IUN
      DIAM=DIA*UF(IUN)
      FOCUS=FOCAL*UF(IUN)
      OFFS(1)=0.
      OFFS(2)=0.
      WRITE(6,3)
    3 FORMAT(' Enter patch increment: subreflector, main ',$)
      READ(5,*)ALINS,ALINM
      IF(ALINS.LE.0.)STOP
      ALINC=ALINS*UF(IUN)
      ALINCM=ALINM*UF(IUN)
      OPEN(66,FILE='durpat.out')
      OPEN(19,FILE='durpat.dat',ACCESS='DIRECT',RECL=76)
      CALL PARGEO(DIAM,FOCUS,OFFS,XC,ALINCM,19)
      WRITE(6,4)
    4 FORMAT(
     1' Enter subreflector diameter effective, actual,',
     1'  effective f/D ',$)
      READ(5,*)DSUB,DSUBA,FED
      WRITE(6,5)
    5 FORMAT(' Enter type: 1 Cassegrain, 2 Gregorian ',$)
      READ(5,*)TYPE
      DSUBM=DSUB*UF(IUN)
      DSUBAM=DSUBA*UF(IUN)
C ---------- Find geometry of subreflector and position of feed
      CALL DURGEO(DIAM,DSUBM,FOD,FED,TYPE,AA,BB,CB,FEED)
      OPEN(21,FILE='block.cur',ACCESS='DIRECT',RECL=76)
C ---------- Find geometry file of subreflector
      CALL SUBGEO(DSUBAM,AA,BB,OFFS,TYPE,CB,ALINC,21)
      OPEN(20,FILE='subrf.cur',ACCESS='DIRECT',RECL=76)
      CALL CUREQU(21,20)
      WRITE(6,6)
    6 FORMAT(' Enter approximation number (1) or (2) ',$)
      READ(5,*)NAPPR
      WRITE(6,7)
    7 FORMAT(' Enter E- and H-plane Beamwidths, Level dB ',$)
      READ(5,*)BE,BH,BWL
      BNE=PATEXP(BE,BWL,NAPPR)
      BNH=PATEXP(BH,BWL,NAPPR)
      WRITE(6,8)
    8 FORMAT(' Enter feed efficiency dB ',$)
      READ(5,*)FEE
      WRITE(6,9)
    9 FORMAT(' Enter polarization: 0 linear, -1 RHC, +1 LHC ',$)
      READ(5,*)POL
      WRITE(6,10)
   10 FORMAT(' Enter rotation angles to point feed at Reflector ',$)
      READ(5,*)EU(1),EU(2),EU(3)
      WRITE(6,11)
   11 FORMAT(' Enter rotation axes: 1 X, 2 Y, 3 Z ',$)
      READ(5,*)IA(1),IA(2),IA(3)
      EUA(1)=EU(1)*TR
      EUA(2)=EU(2)*TR
      EUA(3)=EU(3)*TR
      CALL EULER(EUA,IA,ROT)
   88 WRITE(6,12)
   12 FORMAT(' Enter feed location relative focus ',$)
      READ(5,*)XFD(1),XFD(2),XFD(3)
      WRITE(66,13)DIA,UN(IUN),FOCAL,DSUB,DSUBA,FED,BE,BH,BWL,FEE,EU(1),
     1 EU(2),EU(3),IA(1),IA(2),IA(3),POL,XFD(1),XFD(2),XFD(3),TYPE
   13 FORMAT(/,' Dual Paraboloidal Reflector',/,
     1' Aperture Diameter:             ',F8.3,A4,/,
     2' Focal Length:                  ',F8.3,/,
     3' Subreflector diameter eff:     ',F8.3,/,
     3' Subreflector diameter actual:  ',F8.3,/,
     4' Effective f/D:                 ',F8.3,/,
     6' E-plane beamwidth:             ',F8.2,/,
     7' H-plane beamwidth:             ',F8.2,/,
     8' Beamwidth level dB:            ',F8.2,/,
     7' Feed Efficiency dB:            ',F8.2,/,
     9' Rotation angles:    ',3F8.2,/,
     1' Axes (1 X, 2 Y, 3 Z)',3I8,/,
     2' Pol. 0 linear, -1 RHC, +1 LHC: ',F8.0,/,
     3' Feed relative focus:',3F8.3,/,
     4' Type: 1 Cassegrain, 2 Gregorian: ',F6.0)
      XFD(1)=XFD(1)*UF(IUN)+FEED(1)
      XFD(2)=XFD(2)*UF(IUN)+FEED(2)
      XFD(3)=XFD(3)*UF(IUN)+FEED(3)
   14 WRITE(6,15)
   15 FORMAT(' Enter Frequency (GHz) ',$)
      READ(5,*)FREQ
      WRITE(66,16)FREQ
   16 FORMAT(/,' Frequency (GHz): ',F9.4)
      PKC=2.*PI*FREQ/CC
C ----------- Find currents on subreflector due to feed
      CALL REFCCU(XFD,PKC,ROT,NAPPR,BNE,BNH,POL,BLOCKN,XB,20)
      CALL CURCOM(20)
C ----------- Use subreflector currents to find main refl. currents
      CALL REFCUR(XC,PKC,BLOCKN,XB,19)
      CALL CURCOM(19)
C ----------- Find central subreflector blockage currents
      CALL SPHCUR(PKC,BLOCKN,XB,21)
C ----------- Load all currents into common
      CALL CURCAT(20)
      CALL CURCAT(21)
   17 WRITE(6,18)
   18 FORMAT(' Enter: 1 Conic Cut, 2 Great Circle, 3 Az & EL ',$)
      READ(5,*)IPAT
      IF(IPAT.EQ.3)GOTO80
      IF(IPAT.EQ.2)THEN
      WRITE(6,19)
   19 FORMAT(' Enter Theta Start,Stop,Step ',$)
      ELSE
      WRITE(6,20)
   20 FORMAT(' Enter Phi Start,Stop,Step ',$)
      ENDIF
      READ(5,*)T1,T2,TS
      NT=(T2-T1)/TS+1.4
      IF(NT.GT.501)STOP
      IF(IPAT.EQ.2)THEN
      WRITE(6,21)
   21 FORMAT(' Enter Constant Phi Angle ',$)
      ELSE
      WRITE(6,22)
   22 FORMAT(' Enter Constant Theta Angle ',$)
      ENDIF
      READ(5,*)AN
      WRITE(6,23)
   23 FORMAT(' Near field pattern? ',$)
      NEAR=NYES(K)
      IF(NEAR.EQ.1)THEN
      WRITE(6,24)
   24 FORMAT(' Enter radius ',$)
      READ(5,*)DIST
      WRITE(66,25)DIST
   25 FORMAT(' Near field pattern at Radius = ',F8.2)
      DIST=DIST*UF(IUN)
      ENDIF
      IF(IPAT.EQ.1)THETA=AN*TR
      IF(IPAT.EQ.2)PHI=AN*TR
      IF(IPAT.EQ.2)WRITE(LU,26)AN
   26 FORMAT(/,' Constant Phi Angle: ',F7.2)
      IF(IPAT.EQ.1)WRITE(LU,27)AN
   27 FORMAT(/,' Constant Theta Angle: ',F7.2)
C
C  CALCULATE PATTERN
C
      DO 30 I=1,NT
      THT(I)=T1+FLOAT(I-1)*TS
      IF(IPAT.EQ.2)THETA=THT(I)*TR
      IF(IPAT.EQ.1)PHI=THT(I)*TR
      CALL FFDIRC(THETA,PHI,VR,VT,VP)
      IF(NEAR.EQ.1)THEN
      DO 28 J=1,3
   28 XF(J)=VR(J)*DIST
      CALL NFPATR(XC,BLOCKN,XB,XF,EFIELD,HFIELD)
      EITH(I)=0.
      EIPH(I)=0.
      DO 29 J=1,3
      EITH(I)=DIST*EFIELD(J)*VT(J)*GCONS+EITH(I)
   29 EIPH(I)=DIST*EFIELD(J)*VP(J)*GCONS+EIPH(I)
      CALL RCSPAT(ROT,NAPPR,THETA,PHI,BNE,BNH,POL,ETHETA,EPHI)
      PHH=-PKC*DOT(XFD,VR)*DIST
      PHAA=CMPLX(COS(PHH),SIN(PHH))/DIST
      EITH(I)=EITH(I)+ETHETA*PHAA*GCONS
      EIPH(I)=EIPH(I)+EPHI*PHAA*GCONS
      ELSE
      CALL FFPATR(XC,BLOCKN,XB,THETA,PHI,EITH(I),EIPH(I))
      CALL RCSPAT(ROT,NAPPR,THETA,PHI,BNE,BNH,POL,ETHETA,EPHI)
      PHH=PKC*DOT(XFD,VR)
      PHAA=CMPLX(COS(PHH),SIN(PHH))
      EITH(I)=(EITH(I)+ETHETA*PHAA)*GCONS
      EIPH(I)=(EIPH(I)+EPHI*PHAA)*GCONS
      ENDIF
   30 CONTINUE
      KPM=-1
   31 IF(IC.EQ.0)GOTO33
      WRITE(6,32)
   32 FORMAT(' Normalize to Last Plot Maximum? ',$)
      KPM=NYES(K)
   33 WRITE(6,34)
   34 FORMAT(' Enter Output Code:',/,4X,' 1 E Theta, 2 E Phi'
     1,' 3 RHC, 4 LHC, 5 Max. Lin., 6 Min. Lin.,'
     2/,' 7 +45 Comp., 8 -45 Comp., 9 Power ',$)
      READ(5,*)IOUT
      AEX=-120.
      DO 35 I=1,NT
      CALL OUTCC(IOUT,EITH(I),EIPH(I),EII)
      CALL PMAGC(EII,AEI(I),PHS)
      AEI(I)=AEI(I)+FEE
      IF(AEI(I).GT.AEX)THEN
      AEX=AEI(I)
      THX=THT(I)
      ELSE
      ENDIF
   35 CONTINUE
   36 IF(IC.EQ.0)EMAX=AEX
      IF(KPM.EQ.-1)EMAX=AEX
      IC=IC+1
      WRITE(6,37)
   37 FORMAT(' Plot 0 none, 1 polar, 2 rectangular ',$)
      READ(5,*)IPLOT
      IF(IPLOT.NE.1)GOTO52
      CALL PPATP(T1,T2,TS,AEI,EMAX,IP)
   52 IF(IPLOT.EQ.2)CALL RCPLT(THT,AEI,NT)
      WRITE(6,53)
   53 FORMAT(' List? ',$)
      IF(NYES(K).EQ.1)THEN
      IF(IPAT.EQ.2)WRITE(LU,56)
      IF(IPAT.EQ.1)WRITE(LU,57)
      IF(IPAT.EQ.2)WRITE(6,56)
      IF(IPAT.EQ.1)WRITE(6,57)
      DO54I=1,NT
      THETA=T1+FLOAT(I-1)*TS
      CALL OUTCC(IOUT,EITH(I),EIPH(I),EII)
      CALL PMAGC(EII,AEX,PHS)
      WRITE(6,55)THETA,AEX,PHS
   54 WRITE(LU,55)THETA,AEX,PHS
   55 FORMAT(F6.1,4X,F7.2,2X,F7.2)
   56 FORMAT(/,' Theta',2X,' Ampl(dB)',3X,' Phase',/)
   57 FORMAT(/,'  Phi ',2X,' Ampl(dB)',3X,' Phase',/)
      ELSE
      END IF
      WRITE(6,58)
   58 FORMAT(' Another Polarization? ',$)
      IF(NYES(K).EQ.1)GOTO31
   86 WRITE(6,59)
   59 FORMAT(' New Pattern Cut? ',$)
      IF(NYES(K).EQ.1)GOTO17
      WRITE(6,60)
   60 FORMAT(' New Frequency? ',$)
      IF(NYES(K).EQ.1)GOTO14
      WRITE(6,87)
   87 FORMAT(' New feed point? ',$)
      IF(NYES(K).EQ.1)GOTO 88
      STOP
   80 WRITE(6,84)
   84 FORMAT(' Enter azimuth (rotation about X) start,stop,step ',$)
      READ(5,*)AZ1,AZ2,AZ3
      WRITE(6,76)
   76 FORMAT(' Enter elevation (rotation about Y) start,stop,step ',$)
      READ(5,*)EL1,EL2,EL3
      WRITE(6,77)
   77 FORMAT(' Enter output file name ',$)
      READ(5,61)FILOUT
   61 FORMAT(A40)
      OPEN(51,FILE=FILOUT)
      WRITE(6,78)
   78 FORMAT(' Enter Polarization Code:',/,' 1 E Theta, 2 E Phi,'
     1' 3 RHC, 4 LHC ',$)
      READ(5,*)IOUT
      WRITE(6,23)
C  23 FORMAT(' Near field pattern? ',$)
      NEAR=NYES(K)
      IF(NEAR.EQ.1)THEN
      WRITE(6,24)
C  24 FORMAT(' Enter radius ',$)
      READ(5,*)DIST
      WRITE(66,25)DIST
C  25 FORMAT(' Near field pattern at Radius = ',F8.2)
      DIST=DIST*UF(IUN)
      ENDIF
      NAZ=(AZ2-AZ1)/AZ3+1.4
      NEL=(EL2-EL1)/EL3+1.4
      DO 81 I=1,NEL
      ELV=EL1+FLOAT(I-1)*EL3
      DO 79 J=1,NAZ
      AZM=AZ1+FLOAT(J-1)*AZ3
      EUA(1)=-AZM*TR
      EUA(2)=ELV*TR
      EUA(3)=0.
      IUA(1)=1
      IUA(2)=2
      IUA(3)=3
      CALL EULER(EUA,IUA,ROTD)
      CALL MTMULT(ZXX,ROTD,XXR,1,3,3)
      CALL RETSP(XXR,OB)
      THETA=OB(2)
      PHI=OB(3)
      CALL FFDIRC(THETA,PHI,VR,VT,VP)
      IF(NEAR.EQ.1)THEN
      DO 82 L=1,3
   82 XF(L)=VR(L)*DIST
      CALL NFPATR(XC,BLOCKN,XB,XF,EFIELD,HFIELD)
      EITH(1)=0.
      EIPH(1)=0.
      DO 83 L=1,3
      EITH(1)=DIST*EFIELD(L)*VT(L)*GCONS+EITH(1)
   83 EIPH(1)=DIST*EFIELD(L)*VP(L)*GCONS+EIPH(1)
      CALL RCSPAT(ROT,NAPPR,THETA,PHI,BNE,BNH,POL,ETHETA,EPHI)
      PHH=-PKC*DOT(XFD,VR)*DIST
      PHAA=CMPLX(COS(PHH),SIN(PHH))/DIST
      EITH(1)=EITH(1)+ETHETA*PHAA*GCONS
      EIPH(1)=EIPH(1)+EPHI*PHAA*GCONS
      ELSE
      CALL FFPATR(XC,BLOCKN,XB,THETA,PHI,EITH(1),EIPH(1))
      CALL RCSPAT(ROT,NAPPR,THETA,PHI,BNE,BNH,POL,ETHETA,EPHI)
      PHH=PKC*DOT(XFD,VR)
      PHAA=CMPLX(COS(PHH),SIN(PHH))
      EITH(1)=(EITH(1)+ETHETA*PHAA)*GCONS
      EIPH(1)=(EIPH(1)+EPHI*PHAA)*GCONS
      ENDIF
      CALL OUTCC(IOUT,EITH(1),EIPH(1),EII)
      CALL PMAGC(EII,AMM,PHH)
      IF(IOUT.EQ.1)CALL OUTCC(2,EITH(1),EIPH(1),EII)
      IF(IOUT.EQ.2)CALL OUTCC(1,EITH(1),EIPH(1),EII)
      IF(IOUT.EQ.3)CALL OUTCC(4,EITH(1),EIPH(1),EII)
      IF(IOUT.EQ.4)CALL OUTCC(3,EITH(1),EIPH(1),EII)
      CALL PMAGC(EII,AMCC,PHCC)
      WRITE(51,85)AZM,ELV,AMM,PHH,AMCC,PHCC
   85 FORMAT(F9.4,F9.4,F9.3,F8.2,F9.3,F8.2)
   79 CONTINUE
   81 CONTINUE
      CLOSE(51)
      GOTO 86
      END
      SUBROUTINE PMAGC(E,AMP,PHASE)
      COMPLEX E
      IF(CABS(E).GT.1.E-12)THEN
      AMP=20.*ALOG10(CABS(E))
      PHASE=ATAN2(AIMAG(E),REAL(E))/.01745329
      ELSE
      AMP=-240.
      PHASE=0
      ENDIF
      RETURN
      END
      SUBROUTINE OUTCC(IOUT,ET,EP,E)
C
C  CONVERTS THETA & PHI COMPONENTS (VOLTAGE) TO
C  AMPLITUDE DB AND PHASE DEG.
C
C  IOUT
C    1 E THETA (HORIZONTAL), 2 E PHI (VERTICAL), 3 RHC, 4 LHC,
C    5 MAX LINEAR, 6 MIN LINEAR
C  ET, EP COMPLEX THETA & PHI COMPONENTS (VOLTAGE)
C  E OUTPUT VOLTAGE
C
      COMPLEX ET,EP,E,F,CJ
      DATA S2/1.4142135/,CJ/(0.,1.)/
      GOTO(1,2,3,4,5,6,8,9,11),IOUT
    1 E=ET
      GOTO7
    2 E=EP
      GOTO7
    3 E=(ET+CJ*EP)/S2
      GOTO7
    4 E=(ET-CJ*EP)/S2
      GOTO7
    5 E=(ET+CJ*EP)/S2
      F=(ET-CJ*EP)/S2
      E=(CABS(E)+CABS(F))/S2
      GOTO7
    6 E=(ET+CJ*EP)/S2
      F=(ET-CJ*EP)/S2
      E=(CABS(E)-CABS(F))/S2
      GOTO7
    8 E=(ET+EP)/S2
      GOTO7
    9 E=(ET-EP)/S2
      GOTO7
   11 E= SQRT(CABS(ET)**2+CABS(EP)**2)
      GOTO7
    7 RETURN
      END
