      SUBROUTINE EULER(EA,IA,AS)
C 
C  Euler Rotation Matrix
C 
C  EA  Array of Euler Angles (radians) Positive gives CCW rotation
C      about axis specified by IA 
C  IA  Array of Axis Designators (1 X-axis, 2 Y-axis, 3 Z-axis) 
C      For example, rotation about Z axis, New Y axis, New Z axis 
C      would require IA to be: 3,2,3
C 
C  AS  (3,3) Matrix of rotation 
C 
      DIMENSION EA(3),IA(3),AS(3,3),AW(3,3),BW(3,3)
      CALL AXRTA(EA(1),IA(1),AS)
      CALL AXRTA(EA(2),IA(2),BW)
      CALL MTMULT(BW,AS,AW,3,3,3) 
      CALL AXRTA(EA(3),IA(3),BW)
      CALL MTMULT(BW,AW,AS,3,3,3) 
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END 
