      SUBROUTINE FFPATF(LUNIT,XC,BLOCK,XB,THETA,PHI,ETHETA,EPHI)
C
C  Far field pattern from currents in file
C
C  LUNIT     Logical unit of open file
C  XC(3)     Position of center of currents
C  BLOCK     Blockage function (external) = 1 when blocked
C  XB        Array of variables for blockage function
C  THETA     Angle from Z axis (boresight) (radians)
C  PHI       Spherical angle from X-axis (radians)
C  ETHETA    Electric field in Theta direction
C  EPHI      Electric field in Phi direction
C
      COMPLEX ETHETA,EPHI,CURJ(3),CURM(3),ETH,EPH,CONJ
      DIMENSION VR(3),VT(3),VP(3),XS(3),XC(3),XB(1),FREC(19)
      INTEGER*4 IBUF(19)
      EQUIVALENCE (IBUF(3),PK),(FREC(8),CURJ(1)),(FREC(14),CURM(1))
      EXTERNAL BLOCK
      DATA CC/.2997925/,PI/3.141592654/
      CALL FFDIRC(THETA,PHI,VR,VT,VP)
      READ(LUNIT,REC=1)(IBUF(NN),NN=1,19)
C ------------- -j*2*Pi*Frequency*Mu
      CONJ=CMPLX(0.,-PK*CC*400.*PI)
      NCUR=IBUF(1)
      NCTYP=IBUF(2)
      ETHETA=0.
      EPHI=0.
      DO 2 I=1,NCUR
      READ(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
      DO 1 J=1,3
    1 XS(J)=FREC(J)+XC(J)
      IF(BLOCK(XB,XS,VR).EQ.0)THEN
      IF(NCTYP.LT.2)THEN
C --------- Electric currents available
      CALL VGREJF(VR,VT,VP,XS,PK,CURJ,ETH,EPH)
      ETHETA=ETHETA+ETH*CONJ
      EPHI=EPHI+EPH*CONJ
      ENDIF
      IF(NCTYP.NE.1)THEN
C --------- Magnetic currents available
      CALL VGRHJF(VR,VT,VP,XS,PK,CURM,ETH,EPH)
      ETHETA=ETHETA-ETH
      EPHI=EPHI-EPH
      ENDIF
      ENDIF
    2 CONTINUE
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
