      SUBROUTINE GREJC(XF,XS,PK,GEJ)
C
C  Complete: Near and far field
C
C  Dyadic Green's function between source current density: J
C  and electric field: E when multiplied by -j(2*pi*frequency)*mu
C  Dyadic Green's function between source current magnetic density: M
C  and the magnetic field: H when multiplied by -j(2*Pi*freq*epsilon)
C
C  XF(3)    Field point (units must match PK)
C  XS(3)    Source point (units must match PK)
C  PK       Propagation constant = 2*Pi/wavelength
C  GEJ(3,3) Free-space Dyadic Green's function (complex)
C
      DIMENSION XF(3),XS(3),RR(3,3)
      COMPLEX GEJ(3,3),CON,CONP,CONN
      DATA FPI/12.5663706/
      CALL RRMAT(XF,XS,RR,R)
      CON=2.*CMPLX(1./R,PK)/PK**2/R-1.
      CONN=CMPLX(1./(R*PK),1.)/(R*PK)
      PHASE=PK*R
      CONP=CMPLX(COS(PHASE),-SIN(PHASE))/FPI/R
      DO1I=1,3
      DO1J=1,3
      GEJ(I,J)=(CON+CONN)*RR(I,J)
      IF(I.EQ.J)GEJ(I,J)=GEJ(I,J)+1.-CONN
    1 GEJ(I,J)=CONP*GEJ(I,J)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
