      FUNCTION HYBRF(XB)
C
C  Hybrid Mode F function to be Zeroed to find Radial Wave Number
C
C  XB     Radial Wavenumber 1/meters
C
      COMMON /HYBM/X
C
C  X(1)   Radius of Waveguide (meters)
C  X(2)   Wall Reactance (due to corrugations or dielectric slab)
C  X(3)   Free Space Propagation Constant 1/meters
C  X(4)   Circumferential mode number: n
C
      DIMENSION X(4)
      DATA ZZ/376.73/
      N=X(4)
      RP=XB*X(1)
      AJN=BESSJN(N,RP)
      AJP=BESJPR(N,RP)
C  ------------- Z axis wavenumber
      BKZ=SQRT(X(3)**2-XB**2)
C  ------------- Characteristic Equation
      HYBRF=RP*X(3)*AJP/(BKZ*N*AJN)+BKZ*N*AJN/
     1 XB/RP/(ZZ*AJN/X(2)-X(3)*AJP/XB)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
