      SUBROUTINE HYMK11(RADIUS,XS,AK0,AKP)
C
C  Hybrid Waveguide Mode Radial wave number for 11 mode
C
C  RADIUS   Waveguide radius
C  XS       Wall reactance
C  AK0      Free space propagation constant
C  AKP      Output Radial Wave Number
C
      DIMENSION XHYB(4)
      COMMON /HYBM/XHYB
C
C  XHYB(1)  Waveguide Radius
C  XHYB(2)  Wall Reactance
C  XHYB(3)  Free space propagation constant
C  XHYB(4)  Circumferential mode number
C
      EXTERNAL HYBRF
      DATA XACC/1.E-5/
      XHYB(1)=RADIUS
      XHYB(2)=XS
      XHYB(3)=AK0
      XHYB(4)=1
      DO 1 I=1,12
      X=(3.2-I*.1)/RADIUS
      IF(HYBRF(X).GT.0.)GOTO2
    1 CONTINUE
    2 AA=(3.2-I*.1)/RADIUS
      BB=(3.3-I*.1)/RADIUS
C ------ RTFLSP ref: Numerical Recipes in FORTRAN, 2nd ed. Cambridge
C        p. 349
      AKP=RTFLSP(HYBRF,AA,BB,XACC)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
