      SUBROUTINE PARGEO(DIA,FOCUS,OFFSET,VP,ALINC,LUNIT)
C
C  Offset Paraboloidal Reflector Geometry for Currents File
C  Polar Grid
C
C  DIA     Diameter of projected reflector
C  FOCUS   Focal length
C  OFFSET  Offset (center of circular aperture in X-Y plane)
C  VP(3)   Location of parent paraboloid vertex
C  ALINC   Length increment in aperture plane for current patches
C  Note:   Paraboloid axis along Z-axis
C  LUNIT   Logical unit of random access file for currents
C
      DIMENSION VP(1),FREC(19),PP(3),OFFSET(2)
      INTEGER*4 IBUF(19)
      DATA PI/3.14159654/
      NR=DIA/ALINC/2.+.5
      HR=DIA/2./NR
      KREC=1
C  ------------- Loop over radius
      DO 2 J=1,NR
      RAD=(FLOAT(J-1)+.5)*HR
C  ------------- Find differential area on aperture plane
      R1=RAD-HR/2.
      R2=RAD+HR/2.
      AREA=(R2**2-R1**2)/2.
      NP=2.*PI*RAD/ALINC+.5
      NP=NP/4
      NP=(NP+1)*4
      HP=2.*PI/NP
C  ------------- Loop over Phi
      DO 1 I=1,NP
      PH=FLOAT(I-1)*HP
      PP(1)=OFFSET(1)+RAD*COS(PH)
      PP(2)=OFFSET(2)+RAD*SIN(PH)
      RP=SQRT(PP(1)**2+PP(2)**2)
      PP(3)=RP*RP/4./FOCUS
C  ------------- Find unit normal
      CALL NORMP(PP,FOCUS,FREC(5))
C  ------------- Adjust area
      FREC(4)=AREA*HP/FREC(7)
      CALL VLINC(1.,VP,1.,PP,FREC)
      KREC=KREC+1
    1 WRITE(LUNIT,REC=KREC)(FREC(NN),NN=1,19)
    2 CONTINUE
      IBUF(1)=KREC-1
      IBUF(2)=1
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
