      PROGRAM PARPAC
C
C  PO analysis of Offset Fed Circular Aperture Paraboloidal Reflector
C
C  Written   22 Sep 95
C  Last Edit 29 Jan 96
C
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
C
      DIMENSION THT(501),AEI(501),VR(3),VT(3),VP(3),XF(3),IAR(3),
     1 XC(3),XFD(3),UF(4),EU(3),IA(3),OFFS(2),CB(3),CBC(3),AX(3)
     1 ,XB(35),ROT(3,3),PE1(3),PE2(3),ROTC(3,3),ZXX(3),XXR(3),SP(3)
      COMPLEX EITH(501),EIPH(501),EII,EFIELD(3),HFIELD(3),
     1 CURJA,CURMA,ETHETA,EPHI,PHAA,EX,EY
      COMMON /PATR/BNE,BNH,NAPPR,POL,CN,SN,BCOEF
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,4000)
      COMMON /CURRENJ/CURJA(3,4000)
      COMMON /CURRENM/CURMA(3,4000)
      CHARACTER UN(4)*4,STRUTF*40,STRDAT*40,NUMM*3,FILOUT*40
      EXTERNAL BLOCKN
      DATA TR/.01745329/,IC/0/,GCONS/.182637/,XC/0.,0.,0./,
     1 PI/3.141592654/,CC/.2997925/
     1,UN/' in.',' ft.',' cm ',' m. '/,UF/.0254,.3048,.01,1./
      LU=66
      WRITE(6,1)
    1 FORMAT(' PO analysis of Offset Paraboloidal Reflector',
     3/,' Enter diameter, focal length, offset ',$)
      READ(5,*)DIA,FOCAL,OFFSET
      WRITE(6,2)
    2 FORMAT(' Enter units: 1 in., 2 ft., 3 cm, 4 m ',$)
      READ(5,*)IUN
      DIAM=DIA*UF(IUN)
      FOCUS=FOCAL*UF(IUN)
      OFFS(1)=OFFSET*UF(IUN)
      OFFS(2)=0.
      WRITE(6,3)
    3 FORMAT(' Enter patch increment ',$)
      READ(5,*)ALIN
      IF(ALIN.LE.0.)STOP
      ALINC=ALIN*UF(IUN)
      OPEN(66,FILE='parpac.out')
      OPEN(19,FILE='parpac.dat',ACCESS='DIRECT',RECL=76)
      CALL PARGEO(DIAM,FOCUS,OFFS,XC,ALINC,19)
      WRITE(6,4)
    4 FORMAT(' Include circular blockage? ',$)
      INBL=NYES(K)
      IF(INBL.EQ.1)THEN
      WRITE(6,5)
    5 FORMAT(' Enter blockage diameter ',$)
      READ(5,*)BLDIA
      BLD=BLDIA*UF(IUN)
      WRITE(6,6)
    6 FORMAT(' Enter center relative to vertex (x,y,z) ',$)
      READ(5,*)CB(1),CB(2),CB(3)
      CBC(1)=CB(1)*UF(IUN)
      CBC(2)=CB(2)*UF(IUN)
      CBC(3)=CB(3)*UF(IUN)
      OPEN(21,FILE='block.cur',ACCESS='DIRECT',RECL=76)
      AX(1)=0.
      AX(2)=0.
      AX(3)=-1.
      CALL RINGEO(AX,0.,BLD,CBC,ALINC,21,0)
      ENDIF
      WRITE(6,64)
   64 FORMAT(' Include struts? ',$)
      NSTRUT=NYES(K)
      IF(NSTRUT.EQ.1)THEN
      WRITE(6,65)
   65 FORMAT(' Enter file name with struts ',$)
      READ(5,66)STRUTF
   66 FORMAT(A40)
      OPEN(70,FILE=STRUTF,STATUS='OLD')
      WRITE(6,3)
      READ(5,*)ALIS
      ALISC=ALIS*UF(IUN)
      ENDIF
      WRITE(6,7)
    7 FORMAT(' Enter approximation number 1, 2 ',$)
      READ(5,*)NAPPR
      WRITE(6,8)
    8 FORMAT(' Enter E- and H-plane Beamwidths, Level dB ',$)
      READ(5,*)BE,BH,BWL
      BNE=PATEXP(BE,BWL,NAPPR)
      BNH=PATEXP(BH,BWL,NAPPR)
      WRITE(6,9)
    9 FORMAT(' Enter polarization: 0 linear, -1 RHC, +1 LHC ',$)
      READ(5,*)POL
      WRITE(6,10)
   10 FORMAT(' Enter feed efficiency dB ',$)
      READ(5,*)FEE
      WRITE(6,11)
   11 FORMAT(' Enter rotation angles to point feed at Reflector ',$)
      READ(5,*)EU(1),EU(2),EU(3)
      WRITE(6,12)
   12 FORMAT(' Enter rotation axes: 1 X, 2 Y, 3 Z ',$)
      READ(5,*)IA(1),IA(2),IA(3)
      WRITE(6,13)
   13 FORMAT(' Enter feed location relative focus ',$)
      READ(5,*)XFD(1),XFD(2),XFD(3)
      WRITE(66,14)DIA,UN(IUN),FOCAL,OFFSET,ALIN,BE,BH,BWL,FEE,EU(1),
     1 EU(2),EU(3),IA(1),IA(2),IA(3),POL,XFD(1),XFD(2),XFD(3)
   14 FORMAT(/,' Offset Fed Paraboloidal Reflector',/,
     1' Aperture Diameter:             ',F8.3,A4,/,
     2' Focal Length:                  ',F8.3,/,
     3' Offset of center:              ',F8.3,/,
     5' Patch length in aperture:      ',F8.3,/,
     6' E-plane beamwidth:             ',F8.2,/,
     7' H-plane beamwidth:             ',F8.2,/,
     8' Beamwidth level dB:            ',F8.2,/,
     9' Feed efficiency dB:            ',F8.2,/,
     9' Rotation angles:    ',3F8.2,/,
     1' Axes (1 X, 2 Y, 3 Z)',3I8,/,
     2' Pol. 0 linear, -1 RHC, +1 LHC: ',F8.0,/,
     3' Feed relative focus:',3F8.3)
      IF(INBL.EQ.1)WRITE(66,15)BLDIA,CB(1),CB(2),CB(3)
   15 FORMAT(
     1' Circular blockage of Diameter: ',F8.3,/,
     2' Center of plate:    ',3F8.3)
      IF(NSTRUT.EQ.1)THEN
      READ(70,*)NSTR
      WRITE(66,67)NSTR
   67 FORMAT(I3,' Struts',/,
     1'  #        Lower End       Diameter',
     2   '        Upper End       Diameter')
   68 FORMAT(I3,8F8.3)
      DO 69 I=1,NSTR
      READ(70,*)(PE1(NN),NN=1,3),DE1,(PE2(NN),NN=1,3),DE2
   69 WRITE(66,68)I,(PE1(NN),NN=1,3),DE1,(PE2(NN),NN=1,3),DE2
      REWIND 70
      ENDIF
      EU(1)=EU(1)*TR
      EU(2)=EU(2)*TR
      EU(3)=EU(3)*TR
      CALL EULER(EU,IA,ROT)
      XFD(1)=XFD(1)*UF(IUN)
      XFD(2)=XFD(2)*UF(IUN)
      XFD(3)=XFD(3)*UF(IUN)+FOCUS
   16 WRITE(6,17)
   17 FORMAT(' Enter Frequency (GHz) ',$)
      READ(5,*)FREQ
      WRITE(66,18)FREQ
   18 FORMAT(/,' Frequency (GHz): ',F9.4)
      PKC=2.*PI*FREQ/CC
      CALL REFCCU(XFD,PKC,ROT,BLOCKN,XB,19)
      IF(NSTRUT.EQ.1)THEN
      READ(70,*)NSTR
      DO 70 I=1,NSTR
      READ(70,*)(PE1(NN),NN=1,3),DE1,(PE2(NN),NN=1,3),DE2
      RE1=DE1*UF(IUN)/2.
      RE2=DE2*UF(IUN)/2.
      DO 71 J=1,3
      PE1(J)=PE1(J)*UF(IUN)
   71 PE2(J)=PE2(J)*UF(IUN)
      LUNIT=70+I
      ICC=I
      DO 74 J=1,2
      IB=ICC/10**(3-J)
      NUMM(J:J)=CHAR(IB+48)
   74 ICC=ICC-IB*10**(3-J)
      NUMM(3:3)=CHAR(ICC+48)
      STRDAT='STR'//NUMM(1:3)//'.DAT'
      WRITE(6,*)LUNIT,STRDAT
      OPEN(LUNIT,FILE=STRDAT,ACCESS='DIRECT',RECL=76)
      CALL CONEGEO(PE1,PE2,RE1,RE2,ALISC,LUNIT,0)
      CALL RFSCCU(XFD,PKC,ROT,BLOCKN,XB,LUNIT,0)
      CALL CURCOM(LUNIT)
   70 CALL REFCUR(XC,PKC,BLOCKN,XB,19,1)
      REWIND 70
      ENDIF
      CALL CURCOM(19)
      IF(NSTRUT.EQ.1)THEN
      READ(70,*)NSTR
      DO 72 I=1,NSTR
      READ(70,*)(PE1(NN),NN=1,3),DE1,(PE2(NN),NN=1,3),DE2
      RE1=DE1*UF(IUN)/2.
      RE2=DE2*UF(IUN)/2.
      DO 73 J=1,3
      PE1(J)=PE1(J)*UF(IUN)
   73 PE2(J)=PE2(J)*UF(IUN)
      LUNIT=70+1
      CALL RFSCUR(XFD,PKC,LUNIT,1)
   72 CALL CURCAT(LUNIT)
      ENDIF
      IF(INBL.EQ.1)CALL SPHCUR(PKC,BLOCKN,XB,21)
      IF(INBL.EQ.1)CALL CURCAT(21)
   19 WRITE(6,20)
   20 FORMAT(' Enter: 1 Conic Cut, 2 Great Circle, 3 Az-El Contour ',$)
      READ(5,*)IPAT
      IF(IPAT.EQ.3)GOTO 75
      IF(IPAT.EQ.2)THEN
      WRITE(6,21)
   21 FORMAT(' Enter Theta Start,Stop,Step ',$)
      ELSE
      WRITE(6,22)
   22 FORMAT(' Enter Phi Start,Stop,Step ',$)
      ENDIF
      READ(5,*)T1,T2,TS
      NT=(T2-T1)/TS+1.4
      IF(NT.GT.501)STOP
      IF(IPAT.EQ.2)THEN
      WRITE(6,23)
   23 FORMAT(' Enter Constant Phi Angle ',$)
      ELSE
      WRITE(6,24)
   24 FORMAT(' Enter Constant Theta Angle ',$)
      ENDIF
      READ(5,*)AN
      WRITE(6,25)
   25 FORMAT(' Near field pattern? ',$)
      NEAR=NYES(K)
      IF(NEAR.EQ.1)THEN
      WRITE(6,26)
   26 FORMAT(' Enter radius ',$)
      READ(5,*)DIST
      WRITE(66,27)DIST
   27 FORMAT(' Near field pattern at Radius = ',F8.2)
      DIST=DIST*UF(IUN)
      ENDIF
      IF(IPAT.EQ.1)THETA=AN*TR
      IF(IPAT.EQ.2)PHI=AN*TR
      IF(IPAT.EQ.2)WRITE(LU,28)AN
   28 FORMAT(/,' Constant Phi Angle: ',F7.2)
      IF(IPAT.EQ.1)WRITE(LU,29)AN
   29 FORMAT(/,' Constant Theta Angle: ',F7.2)
C
C  CALCULATE PATTERN
C
      DO32I=1,NT
      THT(I)=T1+FLOAT(I-1)*TS
      IF(IPAT.EQ.2)THETA=THT(I)*TR
      IF(IPAT.EQ.1)PHI=THT(I)*TR
      CALL FFDIRC(THETA,PHI,VR,VT,VP)
      IF(NEAR.EQ.1)THEN
      DO30J=1,3
   30 XF(J)=VR(J)*DIST
      CALL NFPATR(XC,BLOCKN,XB,XF,EFIELD,HFIELD)
      EITH(I)=0.
      EIPH(I)=0.
      DO31J=1,3
      EITH(I)=DIST*EFIELD(J)*VT(J)*GCONS+EITH(I)
   31 EIPH(I)=DIST*EFIELD(J)*VP(J)*GCONS+EIPH(I)
      ELSE
      CALL FFPATR(XC,BLOCKN,XB,THETA,PHI,EITH(I),EIPH(I))
      CALL RCSPAT(ROT,THETA,PHI,ETHETA,EPHI)
      PHH=PKC*DOT(XFD,VR)
      PHAA=CMPLX(COS(PHH),SIN(PHH))
      EITH(I)=(EITH(I)+ETHETA*PHAA)*GCONS
      EIPH(I)=(EIPH(I)+EPHI*PHAA)*GCONS
      ENDIF
   32 CONTINUE
      KPM=-1
   33 IF(IC.EQ.0)GOTO35
      WRITE(6,34)
   34 FORMAT(' Normalize to Last Plot Maximum? ',$)
      KPM=NYES(K)
   35 WRITE(6,36)
   36 FORMAT(' Enter Output Code:',/,4X,' 1 E Theta, 2 E Phi'
     1,' 3 RHC, 4 LHC, 5 Max. Lin., 6 Min. Lin.,'
     2/,' 7 +45 Comp., 8 -45 Comp., 9 Power ',$)
      READ(5,*)IOUT
      AEX=-120.
      DO37I=1,NT
      CALL OUTCC(IOUT,EITH(I),EIPH(I),EII)
      CALL PMAGC(EII,AEI(I),PHS)
      AEI(I)=AEI(I)+FEE
      IF(AEI(I).GT.AEX)THEN
      AEX=AEI(I)
      THX=THT(I)
      ELSE
      ENDIF
   37 CONTINUE
   38 IF(IC.EQ.0)EMAX=AEX
      IF(KPM.EQ.-1)EMAX=AEX
      IC=IC+1
      WRITE(6,39)
   39 FORMAT(' Plot 0 none, 1 polar, 2 rectangular ',$)
      READ(5,*)IPLOT
      IF(IPLOT.NE.1)GOTO55
      CALL PPATP(T1,T2,TS,AEI,EMAX,IP)
   55 IF(IPLOT.EQ.2)CALL RCPLT(THT,AEI,NT)
      WRITE(6,56)
   56 FORMAT(' List? ',$)
      IF(NYES(K).EQ.1)THEN
      IF(IPAT.EQ.2)WRITE(LU,59)
      IF(IPAT.EQ.1)WRITE(LU,60)
      IF(IPAT.EQ.2)WRITE(6,59)
      IF(IPAT.EQ.1)WRITE(6,60)
      DO57I=1,NT
      THETA=T1+FLOAT(I-1)*TS
      CALL OUTCC(IOUT,EITH(I),EIPH(I),EII)
      CALL PMAGC(EII,AEX,PHS)
      WRITE(6,58)THETA,AEX,PHS
   57 WRITE(LU,58)THETA,AEX,PHS
   58 FORMAT(F6.1,4X,F7.2,2X,F7.2)
   59 FORMAT(/,' Theta',2X,' Ampl(dB)',3X,' Phase',/)
   60 FORMAT(/,'  Phi ',2X,' Ampl(dB)',3X,' Phase',/)
      ELSE
      END IF
      WRITE(6,61)
   61 FORMAT(' Another Polarization? ',$)
      IF(NYES(K).EQ.1)GOTO33
      GOTO76
   75 WRITE(6,77)
   77 FORMAT(' Enter azimuth  start,stop,step ',$)
      READ(5,*)X1,X2,X3
      NX=(X2-X1)/X3+1.4
      WRITE(6,78)
   78 FORMAT(' Enter elevation start,stop,step ',$)
      READ(5,*)Y1,Y2,Y3
      NY=(Y2-Y1)/Y3+1.4
      WRITE(6,79)
   79 FORMAT(' Enter output file name ',$)
      READ(5,80)FILOUT
   80 FORMAT(A40)
      OPEN(55,FILE=FILOUT)
      WRITE(6,81)
   81 FORMAT(' Enter Polarization Code:',/,
     1' 1 E Theta, 2 E Phi, 3 RHC, 4 LHC ',$)
      READ(5,*)IOUT
      ZXX(1)=0.
      ZXX(2)=0.
      ZXX(3)=1.
      DO 82 I=1,NY
      ANGY=Y1+FLOAT(I-1)*Y3
      DO 82 J=1,NX
      ANGX=X1+FLOAT(J-1)*X3
      SP(1)=ANGY*TR
      SP(2)=ANGX*TR
      SP(3)=0.
      IAR(1)=2
      IAR(2)=1
      IAR(3)=3
      CALL EULER(SP,IAR,ROTC)
      CALL MTMULT(ZXX,ROTC,XXR,1,3,3)
      CALL RETSP(XXR,SP)
      CALL FFDIRC(SP(2),SP(3),VR,VT,VP)
      CALL FFPATR(XC,BLOCKN,XB,SP(2),SP(3),EX,EY)
      CALL RCSPAT(ROT,SP(2),SP(3),ETHETA,EPHI)
      PHH=PKC*DOT(XFD,VR)
      PHAA=CMPLX(COS(PHH),SIN(PHH))
      EX=(EX+ETHETA*PHAA)*GCONS
      EY=(EY+EPHI*PHAA)*GCONS
      CALL OUTCC(IOUT,EX,EY,EII)
      CALL PMAGC(EII,AM,PH)
      IF(IOUT.EQ.1)CALL OUTCC(2,EX,EY,EII)
      IF(IOUT.EQ.2)CALL OUTCC(1,EX,EY,EII)
      IF(IOUT.EQ.3)CALL OUTCC(4,EX,EY,EII)
      IF(IOUT.EQ.4)CALL OUTCC(3,EX,EY,EII)
      CALL PMAGC(EII,AMC,PHC)
      AM=AM+FEE
      AMC=AMC+FEE
   82 WRITE(55,83)ANGX,ANGY,AM,PH,AMC,PHC
   83 FORMAT(F8.2,F8.3,F9.3,F8.2,F9.3,F8.2)
      CLOSE(55)
   76 WRITE(6,62)
   62 FORMAT(' New Pattern Cut? ',$)
      IF(NYES(K).EQ.1)GOTO19
      WRITE(6,63)
   63 FORMAT(' New Frequency? ',$)
      IF(NYES(K).EQ.1)GOTO16
      END
      SUBROUTINE PMAGC(E,AMP,PHASE)
      COMPLEX E
      IF(CABS(E).GT.1.E-12)THEN
      AMP=20.*ALOG10(CABS(E))
      PHASE=ATAN2(AIMAG(E),REAL(E))/.01745329
      ELSE
      AMP=-240.
      PHASE=0
      ENDIF
      RETURN
      END
      SUBROUTINE OUTCC(IOUT,ET,EP,E)
C
C  CONVERTS THETA & PHI COMPONENTS (VOLTAGE) TO
C  AMPLITUDE DB AND PHASE DEG.
C
C  IOUT
C    1 E THETA (HORIZONTAL), 2 E PHI (VERTICAL), 3 RHC, 4 LHC,
C    5 MAX LINEAR, 6 MIN LINEAR
C  ET, EP COMPLEX THETA PHI COMPONENTS (VOLTAGE)
C  E OUTPUT VOLTAGE
C
      COMPLEX ET,EP,E,F,CJ
      DATA S2/1.4142135/,CJ/(0.,1.)/
      GOTO(1,2,3,4,5,6,8,9,11),IOUT
    1 E=ET
      GOTO7
    2 E=EP
      GOTO7
    3 E=(ET+CJ*EP)/S2
      GOTO7
    4 E=(ET-CJ*EP)/S2
      GOTO7
    5 E=(ET+CJ*EP)/S2
      F=(ET-CJ*EP)/S2
      E=(CABS(E)+CABS(F))/S2
      GOTO7
    6 E=(ET+CJ*EP)/S2
      F=(ET-CJ*EP)/S2
      E=(CABS(E)-CABS(F))/S2
      GOTO7
    8 E=(ET+EP)/S2
      GOTO7
    9 E=(ET-EP)/S2
      GOTO7
   11 E= SQRT(CABS(ET)**2+CABS(EP)**2)
      GOTO7
    7 RETURN
      END
