      SUBROUTINE PLBGEO(XMIN,XMAX,YMIN,YMAX,BLOCK,XB,
     1 VP,NX,NY,LUNIT)
C
C  Flat Plate Geometry for Currents File
C  using rectangular grid and external blockage function for rim
C
C  XMIN    Minimum X axis position of rim
C  XMAX    Maximum X axis position of rim
C  YMIN    Minimum Y axis position of rim
C  YMAX    Maximum Y axis position of rim
C  BLOCK   External blockage function to determine rim shape
C  XB( )   Blockage function variables
C  VP(3)   Location of center
C  Note:   Normal along Z-axis
C  NX      Number of points in X-axis integrals
C  NY      Number of points in Y-axis integrals
C  LUNIT   Logical unit of random access file for currents
C
      DIMENSION VP(1),FREC(19),PP(3),XB(1),VR(3)
      INTEGER*4 IBUF(19)
      EXTERNAL BLOCK
      DATA VR/0.,0.,1./
      HX=(XMAX-XMIN)/NX
      HY=(YMAX-YMIN)/NY
      FREC(4)=HX*HY
      FREC(5)=0.
      FREC(6)=0.
      FREC(7)=1.
      KREC=1
C  ------------- Loop over X-axis
      DO 2 J=1,NX
      PP(1)=XMIN+HX*(J-.5)
      DO 1 I=1,NY
      PP(2)=YMIN+HY*(I-.5)
      PP(3)=-1.
      IF(BLOCK(XB,PP,VR).EQ.1.)THEN
C  ------------- Point within rim
      PP(3)=0.
      CALL VLINC(1.,VP,1.,PP,FREC)
      KREC=KREC+1
      WRITE(LUNIT,REC=KREC)(FREC(NN),NN=1,19)
      ENDIF
    1 CONTINUE
    2 CONTINUE
      IBUF(1)=KREC-1
      IBUF(2)=1
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
