      PROGRAM po01
C
C  FORTRAN repeat of example: Uniform Magnetic Current for 30 wave.
C
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,2000)
      COMMON /CURRENJ/CURJA(3,2000)
      COMMON /CURRENM/CURMA(3,2000)
C
C  CURRENT Common
C
C  NCUR     Number of points
C  NCTYP    Current types: 0 both, 1 electric only, 2 magnetic only
C  PKC      Propagation constant (1./meters)
C  POSC     Position of current element (meters)
C  CURJA    Electric current * area rectangular components (complex)
C  CURMA    Magnetic current * area rectangular components (complex)
C
      COMPLEX CURJA,CURMA,EFIELD(3),HFIELD(3)
      DIMENSION AXIS(500),FIELD(500),XC(3),XF(3),XB(1)
      EXTERNAL BLOCKN
      DATA XC/0.,0.,0./
      ALEN=30
      NPTS=30
C ------- Open random access file for currents
      OPEN(19,FILE='PO01.DAT',ACCESS='DIRECT',RECL=76)
C ------- Create file with currents
      CALL LINCUR(ALEN,NPTS,19)
C ------- Load currents into common
      CALL CURCOM(19)
      EMAX=-5000
C ------- Scan in plane with line source as normal
      XF(2)=0.
      XF(3)=0.
      DO 1 I=1,500
      AXIS(I)=.002*I
      XF(1)=AXIS(I)*2.*ALEN**2
      CALL NFPATR(XC,BLOCKN,XB,XF,EFIELD,HFIELD)
      FIELD(I)=CABS(EFIELD(2))*XF(1)
      IF(FIELD(I).GT.EMAX)EMAX=FIELD(I)
    1 CONTINUE
C -------- Normalize to peak
      DO 2 I=1,501
    2 FIELD(I)=20.*ALOG10(FIELD(I)/EMAX)
C -------- Call a plotting package for rectangular plot
      CALL PLOT(AXIS,FIELD,500)
      CLOSE(19,STATUS='DELETE')
      END
      SUBROUTINE LINCUR(ALEN,NPTS,LUNIT)
C
C  Currents file for uniform magnetic current along Z axis
C
C  ALEN    Length (wavelengths)
C  NPTS    Number of points
C  LUNIT   Logical unit of random access file with currents
C
      DIMENSION FREC(19)
      INTEGER*4 IBUF(19)
      COMPLEX CURM(3)
      EQUIVALENCE (IBUF(3),PK),(FREC(14),CURM(1))
      DATA PI/3.14159265/
      PK=2.*PI
C ----------- Write first record: # points, current type, Propagation
      IBUF(1)=NPTS
      IBUF(2)=2
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      CURM(1)=0.
      CURM(2)=0.
      CURM(3)=1.
      FREC(1)=0.
      FREC(2)=0.
      ALENI=ALEN/NPTS
      DO 1 I=1,NPTS
C ----------- Sample at center of each increment
      FREC(3)=-ALEN/2.+(I-.5)*ALENI
    1 WRITE(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
