      PROGRAM po02
C
C  FORTRAN repeat of example: Uniform Magnetic Current for 30 wave.
C
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,2000)
      COMMON /CURRENJ/CURJA(3,2000)
      COMMON /CURRENM/CURMA(3,2000)
      COMPLEX CURJA,CURMA,EFIELD(3),HFIELD(3),ETHETA,EPHI
      DIMENSION ANGLE(2001),FIELD(2001),FAR(2001),XC(3),XF(3),XB(1)
      EXTERNAL BLOCKN
      DATA XC/0.,0.,0./,TR/.01745329/
      ALEN=30
      NPTS=30
C ------- Open random access file for currents
      OPEN(19,FILE='PO01.DAT',ACCESS='DIRECT',RECL=76)
C ------- Create file with currents
      CALL LINCUR(ALEN,NPTS,19)
C ------- Load currents into common
      CALL CURCOM(19)
      EMAX=-5000
C ------- Scan in X-Z plane along a circle
      XF(2)=0.
      RO=.2*2.*ALEN**2
      DO 1 I=1,2001
      ANGLE(I)=-20.+FLOAT(I-1)*.02
      THETA=(90.+ANGLE(I))*TR
      XF(1)=RO*SIN(THETA)
      XF(3)=RO*COS(THETA)
C ------- Near Field Pattern
      CALL NFPATR(XC,BLOCKN,XB,XF,EFIELD,HFIELD)
      FIELD(I)=CABS(EFIELD(2))*RO
      PHI=0.
C ------- Far Field Pattern
      CALL FFPATR(XC,BLOCKN,XB,THETA,PHI,ETHETA,EPHI)
      FAR(I)=CABS(EPHI)
      IF(FAR(I).GT.EMAX)EMAX=FAR(I)
    1 CONTINUE
C -------- Normalize to peak
      DO 2 I=1,2001
      FAR(I)=20.*ALOG10(FAR(I)/EMAX)
    2 FIELD(I)=20.*ALOG10(FIELD(I)/EMAX)
      CALL PLOT(ANGLE,FAR,2001)
      CALL PLOT(ANGLE,FIELD,2001)
      CLOSE(19,STATUS='DELETE')
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      END
