      FUNCTION POLYIN(PT,VT,NV,AN)
C
C  Whether point PT, an intersection with the planar polygon, is
C  inside (+1) or outside (-1) the polygon
C
C  PT(3)     Intersection point with plane
C  VT(3,NT)  Vertices of the polygon ordered CCW around Normal
C  NV        Number of vertices
C  AN(3)     Plane unit normal
C
      DIMENSION PT(1),VT(1),V1(3),V2(3),AN(3),XX(3)
      DATA PI/3.141592654/
      POLYIN=1
      THMT=0.
      DO 2 I=1,NV-1
      K=3*(I-1)
      KK=3*I
      DO 1 J=1,3
      V1(J)=VT(K+J)-PT(J)
    1 V2(J)=VT(KK+J)-PT(J)
      CALL CROSS(V1,V2,XX)
    2 THMT=THMT+ATAN2(DOT(XX,AN),DOT(V1,V2))
      K=3*(NV-1)
      DO 3 J=1,3
      V1(J)=VT(K+J)-PT(J)
    3 V2(J)=VT(J)-PT(J)
      CALL CROSS(V1,V2,XX)
      THMT=THMT+ATAN2(DOT(XX,AN),DOT(V1,V2))
      IF(ABS(THMT).LT.PI)POLYIN=-1
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
