      SUBROUTINE RECCUR(W,H,NM,MM,SLANTY,SLANTX,AKZ,AKF,NY,NX,LUNIT)
C
C  Currents File of Rectangular Waveguide Horn in TE mode
C
C  W       Width of horn aperture along Y axis (m)
C  H       Height of horn aperture along X axis (m)
C  NM      Mode number along Y axis
C  MM      Mode number along X axis
C  SLANTY  Slant radius in Y axis plane
C  SLANTX  Slant radius in X axis plane
C  AKZ     Z-axis propagation constant in waveguide
C  AKF     Propagation constant in free space
C  NY      Number of points in Y axis (width) integrals
C  NX      Number of points in X axis (height) integrals
C  LUNIT   Logical unit of random access file for currents
C
      COMPLEX CURJ(3),CURM(3),QUADY,QUADX
      DIMENSION FREC(19)
      INTEGER*4 IBUF(19)
      EQUIVALENCE (IBUF(3),PK),(FREC(8),CURJ(1)),(FREC(14),CURM(1))
      DATA PI/3.141592654/,CC/.2997925/
      HX=H/NX
      HY=W/NY
      FREC(4)=HX*HY
      CURJ(3)=0.
      CURM(3)=0.
      FREC(3)=0.
      CONS=AKF*CC*400.*PI
      POWER=0.
      PK=AKF
      IBUF(1)=NX*NY
      IBUF(2)=0
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      KREC=1
C ------- Loop along Y axis
      DO 1 I=1,NY
      FREC(2)=-W/2.+HY*(I-.5)
      Y=HY*(I-.5)
      SS=AKF*FREC(2)**2/SLANTY/2.
      QUADY=CMPLX(COS(SS),-SIN(SS))
C ------- Loop along X axis
      DO 1 J=1,NX
      FREC(1)=-H/2.+HX*(J-.5)
      X=HX*(J-.5)
      SS=AKF*FREC(1)**2/SLANTX/2.
      QUADX=CMPLX(COS(SS),-SIN(SS))*QUADY*FREC(4)
      CURJ(1)=-AKZ*SIN(NM*PI*Y/W)*COS(MM*PI*X/H)*NM*PI/W/CONS*QUADX
      CURJ(2)=-AKZ*MM*PI/H*COS(NM*PI*Y/W)*SIN(MM*PI*X/H)/CONS*QUADX
      CURM(1)=MM*PI/H*COS(NM*PI*Y/W)*SIN(MM*PI*X/H)*QUADX
      CURM(2)=-NM*PI/W*SIN(NM*PI*Y/W)*COS(MM*PI*X/H)*QUADX
      KREC=KREC+1
      WRITE(LUNIT,REC=KREC)(FREC(NN),NN=1,19)
    1 POWER=POWER+(CABS(CURM(1)*CURJ(2))
     1 +CABS(CURM(2)*CURJ(1)))/FREC(4)
      CURN=SQRT(POWER)
      DO 3 I=2,KREC
      READ(LUNIT,REC=I)(FREC(NN),NN=1,19)
      DO 2 J=1,3
      CURJ(J)=CURJ(J)/CURN
    2 CURM(J)=CURM(J)/CURN
    3 WRITE(LUNIT,REC=I)(FREC(NN),NN=1,19)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
