      SUBROUTINE REHCUR(XFD,PKC,BLOCK,XB,LUNIT,IADD)
C
C  Reflector surface currents added to Geometry File
C  using Currents Common Source
C
C  XFD(3)   Location of feed (movement of currents)
C  PKC      Propagation constant
C  BLOCK    Blockage function (external) = 1 when blocked
C  XB       Array of variables for blockage function
C  LUNIT    Logical unit of random access currents file
C  IADD     If 1, add to existing currents
C
      DIMENSION XFD(3),FREC(19),XB(1)
      COMPLEX CURJ(3),EFIELD(3),HFIELD(3),UNIT(3),CUJJ(3),CUMM(3)
     1,CURM(3)
      INTEGER*4 IBUF(19)
      EQUIVALENCE (IBUF(3),PK),(FREC(8),CURJ(1)),(FREC(14),CURM(1))
      EXTERNAL BLOCK
      READ(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      PK=PKC
      IBUF(2)=0
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
C  ------------- Loop over current patches
      DO 3 I=1,IBUF(1)
      READ(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
C  ----------- Find fields at the surface of the reflector
      CALL NFPATR(XFD,BLOCK,XB,FREC,EFIELD,HFIELD)
      DO 1 J=1,3
      UNIT(J)=FREC(J+4)*FREC(4)
    1 EFIELD(J)=-EFIELD(J)
      CALL CCROSS(UNIT,HFIELD,CUJJ)
      CALL CCROSS(EFIELD,UNIT,CUMM)
      DO 2 J=1,3
      IF(IADD.EQ.1)THEN
      CURJ(J)=CUJJ(J)+CURJ(J)
      CURM(J)=CUMM(J)+CURM(J)
      ELSE
      CURJ(J)=CUJJ(J)
      CURM(J)=CUMM(J)
      ENDIF
    2 CONTINUE
    3 WRITE(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
