      SUBROUTINE RFSCUR(XFD,PKC,LUNIT,IADD)
C
C  Reflector surface currents added to Geometry File
C  using Current Common - Shadow only normal toward current included
C
C  XFD(3)   Location of feed - Assumes currents centered on feed
C  PKC      Propagation constant
C  LUNIT    Logical unit of random access currents file
C  IADD     If 1, add to existing currents
C
C  The routine assumes that the currents in common have been rotated
C  to the proper orientation to point at the reflector; see FILROT
C
      DIMENSION XFD(3),FREC(19),XB(4)
      INTEGER*4 IBUF(19)
      COMPLEX CURJ(3),EFIELD(3),HFIELD(3),UNIT(3),CURM(3)
      EQUIVALENCE (FREC(8),CURJ(1)),(IBUF(3),PK),(FREC(14),CURM(1))
      EXTERNAL SHADOW
      READ(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      IBUF(2)=1
      PK=PKC
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      DO 4 I=1,IBUF(1)
      READ(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
      DO 1 J=1,3
    1 XB(J)=FREC(J+4)
C  ----------- Find fields at the surface of the reflector
      CALL NFPATR(XFD,SHADOW,XB,FREC,EFIELD,HFIELD)
      DO 2 J=1,3
C  ----------- 2*(Surface Normal)*(Patch Area)
    2 UNIT(J)=2.*FREC(J+4)*FREC(4)
      CALL CCROSS(UNIT,HFIELD,EFIELD)
      DO 3 J=1,3
      CURM(J)=0.
      IF(IADD.NE.1)CURJ(J)=EFIELD(J)
      IF(IADD.EQ.1)CURJ(J)=CURJ(J)+EFIELD(J)
    3 CONTINUE
    4 WRITE(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
