      PROGRAM RHMPAT
C
C  Pattern of Rectangular Waveguide Horn
C
C  Written   20 Mar 95
C  Last Edit 21 Mar 95
C
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
C
      DIMENSION AMPL(361),PHASE(361),ANGLE(361),UF(3),VR(3),VT(3),
     1 VP(3),XF(3),XC(3),XB(3)
      COMPLEX ETH(361),EPH(361),EII,EF(3),HF(3),CURJA,CURMA
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,2000)
      COMMON /CURRENJ/CURJA(3,2000)
      COMMON /CURRENM/CURMA(3,2000)
      DIMENSION MODX(9),MODY(9),MODTY(9),PMODE(9),PHMOD(9),
     1 POWWR(9)
      EXTERNAL BLOCKN
      CHARACTER UN(3)*4,FILECU(9)*20
      DATA PI/3.141592654/,TR/.01745329/,GCONS/.182637/,CC/.2997925/,
     1 UF/.0254,.01,1./,UN/' in.',' cm ',' m  '/,
     2 HCONS/68.805/,XC/0.,0.,0./
      WIDL=.114
      HEIL=.15
      IC=0
      OPEN(66,FILE='rhmpat.out')
      OPEN(19,FILE='rhmpat.dat',ACCESS='DIRECT',RECL=76)
    1 WRITE(6,2)
    2 FORMAT(' Pattern of Rectangular Waveguide Horn',/,
     1' Enter aperture X axis height, Y axis width ',$)
      READ(5,*)HEIGHT,WIDTH
      WRITE(6,3)
    3 FORMAT(' Enter length units: 1 in., 2 cm, 3 m ',$)
      READ(5,*)IUN
      HT=HEIGHT*UF(IUN)
      WT=WIDTH*UF(IUN)
      WRITE(6,4)
    4 FORMAT(' Enter slant radius: X-Z, Y-Z Planes ',$)
      READ(5,*)SLANTX,SLANTY
      SLANX=SLANTX*UF(IUN)
      SLANY=SLANTY*UF(IUN)
      WRITE(6,5)
    5 FORMAT(' Enter number of modes ',$)
      READ(5,*)MODES
      DO 9 I=1,MODES
      WRITE(6,6)I
    6 FORMAT(I3,' Mode: Enter mode numbers X,Y ',$)
      READ(5,*)MODX(I),MODY(I)
      WRITE(6,7)
    7 FORMAT(' Enter mode type: 1 TE, 2 TM ',$)
      READ(5,*)MODTY(I)
      WRITE(6,8)
    8 FORMAT(' Enter power (w), phase (deg) ',$)
    9 READ(5,*)PMODE(I),PHMOD(I)
      WRITE(66,10)HEIGHT,UN(IUN),WIDTH,SLANTX,SLANTY
   10 FORMAT(/,' Rectangular horn',/,
     2' X-axis height:            ',F8.4,A4,/,
     5' Y-axis width:             ',F8.4,/,
     1' X-Z plane slant radius:   ',F8.3,/,
     2' Y-Z plane slant radius:   ',F8.3)
   11 WRITE(6,12)
   12 FORMAT(' Edit mode? ',$)
      IF(NYES(K).EQ.1)THEN
   13 WRITE(6,14)
   14 FORMAT(' Enter mode number (0 to terminates) ',$)
      READ(5,*)II
      IF(II.LE.0.OR.II.GT.MODES)GOTO21
   15 WRITE(6,16)MODTY(II),MODX(II),MODY(II),PMODE(II),PHMOD(II)
   16 FORMAT(' 0 stop',/,' 1. Mode type: 1 TE, 2 TM ',I2,/,
     1' 2. X-axis mode ',I3,/,' 3. Y-axis mode ',I3,/,
     2' 4. Power ',F8.3,/,' 5. Phase ',F7.2,' Enter: ',$)
      READ(5,*)IEDT
      IF(IEDT.EQ.0)GOTO13
      IF(IEDT.EQ.1)THEN
      WRITE(6,7)
      READ(5,*)MODTY(II)
      ELSE IF(IEDT.EQ.2)THEN
      WRITE(6,17)
   17 FORMAT(' Enter X-axis mode number ',$)
      READ(5,*)MODX(II)
      ELSE IF(IEDT.EQ.3)THEN
      WRITE(6,18)
   18 FORMAT(' Enter Y-axis mode number ',$)
      READ(5,*)MODY(II)
      ELSE IF(IEDT.EQ.4)THEN
      WRITE(6,19)
   19 FORMAT(' Enter mode power ',$)
      READ(5,*)PMODE(II)
      ELSE IF(IEDT.EQ.5)THEN
      WRITE(6,20)
   20 FORMAT(' Enter phase ',$)
      READ(5,*)PHMOD(II)
      ENDIF
      GOTO15
      ENDIF
   21 POWW=0.
      WRITE(66,22)
   22 FORMAT(' Mode Type  Mode Number  Mode Number  Power   Phase',/,
     1       ' 1 TE, 2 TM    X-axis       Y-axis')
   23 FORMAT(I5,I13,I13,F11.3,F8.2)
      DO 24 I=1,MODES
      WRITE(66,23)MODTY(I),MODX(I),MODY(I),PMODE(I),PHMOD(I)
   24 POWW=PMODE(I)+POWW
      DO 25 I=1,MODES
   25 POWWR(I)=PMODE(I)/POWW
      WRITE(6,26)
   26 FORMAT(' Enter integral numbers: X axis, Y axis ',$)
      READ(5,*)NX,NY
   27 WRITE(6,28)
   28 FORMAT(
     2' Enter Frequency (GHz) ',$)
      READ(5,*)FREQ
      AKF=2.*PI*FREQ/CC
      DO 29 I=1,MODES
      FILECU(I)='RECH'//CHAR(I+48)//'.DAT'
      LUNIT=20+I
      OPEN(LUNIT,FILE=FILECU(I),ACCESS='DIRECT',RECL=76)
      AKZ=SQRT(AKF**2-(MODX(I)*PI/HT)**2-(MODY(I)*PI/WT)**2)
      IF(MODTY(I).EQ.1)CALL RECCUR(WT,HT,MODY(I),MODX(I),SLANY,
     1 SLANX,AKZ,AKF,NY,NX,LUNIT)
      IF(MODTY(I).EQ.2)CALL RMCCUR(WT,HT,MODY(I),MODX(I),SLANY,
     1 SLANX,AKZ,AKF,NY,NX,LUNIT)
   29 CONTINUE
      CALL CURCOM(21)
      IF(MODES.GT.1)THEN
      CALL SCACOM(POWWR(1),PHMOD(1))
      DO 30 I=2,MODES
      LUNIT=20+I
      CALL CURSUM(POWWR(I),PHMOD(I),LUNIT)
   30 CLOSE(LUNIT,STATUS=' DELETE')
      ENDIF
      CLOSE(21,STATUS='DELETE')
      CALL CURSAV(19)
      WRITE(66,31)FREQ,NX,NY
   31 FORMAT(/,
     1' Operating Frequency (GHz):',F8.3,/,
     2' Integral numbers:         ',I8,I8)
   32 WRITE(6,33)
   33 FORMAT(' Pattern: 0 None, 1 Conic, 2 Great Circle,',
     1' 3 Axis impedance ',$)
      READ(5,*)IPAT
      IF(IPAT.EQ.0)GOTO77
      IF(IPAT.EQ.3)GOTO81
      IF(IPAT.EQ.1)THEN
      WRITE(6,34)
   34 FORMAT(' Enter Theta ',$)
      READ(5,*)THETA
      THT=THETA*TR
      WRITE(6,35)
   35 FORMAT(' Enter Phi Start,Stop,Step ',$)
      ELSE IF(IPAT.EQ.2)THEN
      WRITE(6,36)
   36 FORMAT(' Enter Phi ',$)
      READ(5,*)PHI
      PHT=PHI*TR
      WRITE(6,37)
   37 FORMAT(' Enter Theta  Start,Stop,Stop ',$)
      ENDIF
      READ(5,*)A1,A2,A3
      NA=(A2-A1)/A3+1.4
      IF(NA.GT.361)GOTO32
      WRITE(6,38)
   38 FORMAT(' Near field pattern? ',$)
      NEAR=NYES(K)
      IF(NEAR.EQ.1)THEN
      WRITE(6,39)UN(IUN)
   39 FORMAT(' Enter radius ',A4,' ',$)
      READ(5,*)DIST
      WRITE(66,40)DIST,UN(IUN)
   40 FORMAT(' Near Field Pattern at Radius = ',F8.3,A4)
      DIST=DIST*UF(IUN)
      WRITE(6,41)
   41 FORMAT(' Pattern based on magnetic field? ',$)
      MODEH=NYES(K)
      ELSE
      MODEH=-1
      ENDIF
      NUPAT=1
   42 WRITE(6,43)
   43 FORMAT(' Enter output: 1 E Theta, 2 E Phi, 3 RHC, 4 LHC,',/,
     1'      5 Max. Linear, 6 Min. Linear ',$)
      READ(5,*)IOUT
      WRITE(6,44)
   44 FORMAT(' Listing? ',$)
      LIST=NYES(K)
      IF(LIST.EQ.1)THEN
      IF(IPAT.EQ.1)THEN
      WRITE(66,45)THETA
      WRITE(6,45)THETA
   45 FORMAT(/,' Constant Theta = ',F7.2,/,
     1'   Phi   Amplitude  Phase')
   46 FORMAT(F8.1,F10.2,F8.2)
      ELSE IF(IPAT.EQ.2)THEN
      WRITE(66,47)PHI
      WRITE(6,47)PHI
   47 FORMAT(/,' Constant Phi = ',F7.2,/,
     1'   Theta  Amplitude  Phase')
      ENDIF
      ENDIF
      AEX=-500.
      DO49I=1,NA
      ANGLE(I)=A1+FLOAT(I-1)*A3
      IF(IPAT.EQ.1)PHT=ANGLE(I)*TR
      IF(IPAT.EQ.2)THT=ANGLE(I)*TR
      IF(NUPAT.EQ.1)THEN
      IF(NEAR.EQ.1)THEN
      CALL FFDIRC(THT,PHT,VR,VT,VP)
      DO 48 J=1,3
   48 XF(J)=VR(J)*DIST
      CALL NFPATR(XC,BLOCKN,XB,XF,EF,HF)
      IF(MODEH.EQ.1)THEN
      ETH(I)=(HF(1)*VT(1)+HF(2)*VT(2)+HF(3)*VT(3))*DIST
      EPH(I)=(HF(1)*VP(1)+HF(2)*VP(2)+HF(3)*VP(3))*DIST
      ELSE
      ETH(I)=(EF(1)*VT(1)+EF(2)*VT(2)+EF(3)*VT(3))*DIST
      EPH(I)=(EF(1)*VP(1)+EF(2)*VP(2)+EF(3)*VP(3))*DIST
      ENDIF
      ELSE
      CALL FFPATR(XC,BLOCKN,XB,THT,PHT,ETH(I),EPH(I))
      ENDIF
      IF(MODEH.EQ.1)THEN
      ETH(I)=ETH(I)*HCONS
      EPH(I)=EPH(I)*HCONS
      ELSE
      ETH(I)=ETH(I)*GCONS
      EPH(I)=EPH(I)*GCONS
      ENDIF
      ENDIF
      CALL OUTCC(IOUT,ETH(I),EPH(I),EII)
      CALL PMAGC(EII,AMPL(I),PHASE(I))
      IF(LIST.EQ.1)THEN
      WRITE(66,46)ANGLE(I),AMPL(I),PHASE(I)
      WRITE(6,46)ANGLE(I),AMPL(I),PHASE(I)
      ENDIF
      IF(AMPL(I).GT.AEX)AEX=AMPL(I)
   49 CONTINUE
      NUPAT=2
      IF(IC.EQ.0)EMAX=AEX
      WRITE(6,50)
   50 FORMAT(' Plot: 0 None, 1 Polar, 2 Rectangular ',$)
      READ(5,*)IPLOT
      IF(IPLOT.EQ.1)THEN
      IF(IC.NE.0)THEN
      WRITE(6,51)
   51 FORMAT(' Normalize to last plot maximum? ',$)
      KPM=NYES(K)
      IF(KPM.NE.1)EMAX=AEX
      ENDIF
      CALL PPATP(A1,A2,A3,AMPL,EMAX,IP)
      IC=1
      ELSE IF(IPLOT.EQ.2)THEN
      CALL RCPLT(ANGLE,AMPL,NA)
      ENDIF
      WRITE(6,76)
   76 FORMAT(' Another polarization? ',$)
      IF(NYES(K).EQ.1)GOTO42
      GOTO32
   77 WRITE(6,78)
   78 FORMAT(' New frequency? ',$)
      IF(NYES(K).EQ.1)GOTO27
   79 WRITE(6,80)
   80 FORMAT(' Another horn? ',$)
      IF(NYES(K).EQ.1)GOTO1
      STOP
   81 WRITE(6,82)
   82 FORMAT(' Enter axis  Start,Stop,Step ',$)
      READ(5,*)A1,A2,A3
      NA=(A2-A1)/A3+1.4
      IF(NA.GT.361)GOTO32
      WRITE(6,83)
   83 FORMAT(' Print-out? ',$)
      LIST=NYES(K)
      IF(LIST.EQ.1)THEN
      WRITE(66,84)
      WRITE(6,84)
   84 FORMAT(' Axis Position  Normalized impedance - 1  Gain dB')
   85 FORMAT(F12.2,F21.7,f15.3)
      ENDIF
      XF(1)=0.
      XF(2)=0.
      DO 86 I=1,NA
      ANGLE(I)=A1+FLOAT(I-1)*A3
      XF(3)=ANGLE(I)*UF(IUN)
      CALL NFPATR(XC,BLOCKN,XB,XF,EF,HF)
      ZWAVE=EF(1)/HF(2)
      AMPL(I)=ZWAVE/376.73-1
      PHASE(I)=20.*ALOG10(CABS(EF(1))*GCONS*XF(3))
      IF(LIST.EQ.1)THEN
      WRITE(66,85)ANGLE(I),AMPL(I),PHASE(I)
      WRITE(6,85)ANGLE(I),AMPL(I),PHASE(I)
      ENDIF
   86 CONTINUE
      WRITE(6,87)
   87 FORMAT(' Plot Normalized Impedance - 1? ',$)
      IF(NYES(K).EQ.1)CALL RCPLT(ANGLE,AMPL,NA)
      WRITE(6,88)
   88 FORMAT(' Plot Gain? ',$)
      IF(NYES(K).EQ.1)CALL RCPLT(ANGLE,PHASE,NA)
      GOTO32
      END
      SUBROUTINE CURSAV(LUNIT)
C
C  Save CURRENT common into file
C
C  LUNIT    Logical unit of random access file (open file)
C
C  File:  76 Bytes record
C
C  Record 1
C
C  Number of records
C  Types of currents available: 0 both, 1 electric only, 2 magnetic only
C  Propagation constant (1./meters)
C
C  Record 2 - NCUR+1
C
C  Position(3)   meters
C  Area          meters**2
C  Normal(3)     Unit normal to patch
C  J(3)          Electric current * area
C  M(3)          Magnetic current * area
C
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,2000)
      COMMON /CURRENJ/CURJA(3,2000)
      COMMON /CURRENM/CURMA(3,2000)
      COMPLEX CURJA,CURMA,CURJ(3),CURM(3)
      DIMENSION FREC(19)
      INTEGER*4 IBUF(19)
      EQUIVALENCE (IBUF(3),PK),(FREC(8),CURJ(1)),(FREC(14),CURM(1))
      IBUF(1)=NCUR
      IBUF(2)=NCTYP
      PK=PKC
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      DO 2 I=1,NCUR
      DO 1 J=1,3
      FREC(J)=POSC(J,I)
      CURJ(J)=CURJA(J,I)
    1 CURM(J)=CURMA(J,I)
    2 WRITE(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
      RETURN
      END
      SUBROUTINE OUTCC(IOUT,ET,EP,E)
C
C  CONVERTS THETA and PHI COMPONENTS (VOLTAGE) TO
C  AMPLITUDE DB AND PHASE DEG.
C
C  IOUT
C    1 E THETA (HORIZONTAL), 2 E PHI (VERTICAL), 3 RHC, 4 LHC,
C    5 MAX LINEAR, 6 MIN LINEAR
C  ET, EP COMPLEX THETA & PHI COMPONENTS (VOLTAGE)
C  E OUTPUT VOLTAGE
C
      COMPLEX ET,EP,E,F,CJ
      DATA S2/1.4142135/,CJ/(0.,1.)/
      GOTO(1,2,3,4,5,6,8,9,11),IOUT
    1 E=ET
      GOTO7
    2 E=EP
      GOTO7
    3 E=(ET+CJ*EP)/S2
      GOTO7
    4 E=(ET-CJ*EP)/S2
      GOTO7
    5 E=(ET+CJ*EP)/S2
      F=(ET-CJ*EP)/S2
      E=(CABS(E)+CABS(F))/S2
      GOTO7
    6 E=(ET+CJ*EP)/S2
      F=(ET-CJ*EP)/S2
      E=(CABS(E)-CABS(F))/S2
      GOTO7
    8 E=(ET+EP)/S2
      GOTO7
    9 E=(ET-EP)/S2
      GOTO7
   11 E= SQRT(CABS(ET)**2+CABS(EP)**2)
      GOTO7
    7 RETURN
      END
