      SUBROUTINE RINPAT(ROT,INST,THETA,PHI,ETHETA,EPHI)
C
C  Rotated
C  Interpolated Measured Pattern
C
C  ROT(3,3) Rotation matrix
C  INST   - 1 Initialize: Read from file of ASCII listing of data
C           2 Return pattern value
C  THETA    Pattern angle (radians) (Value to add to bias to gain
C              on initialization dB)
C  PHI      Pattern angle (radians) (Value to add to bias to gain
C              on initialization dB)
C  ETHETA   Theta component  V/m for 1 watt radiated power at 1 m.
C  EPHI     Phi component    V/m for 1 watt radiated power at 1 m.
C
      COMPLEX ETHETA,EPHI,ETHETE,EPHE
      DIMENSION ROT(3,3),VR(3),VT(3),VP(3),VTP(3),VPP(3),
     1 VRR(3),VTR(3),VPR(3)
      DATA TR/.01745329/
      IF(INST.EQ.1)THEN
      CALL PATIND(INST,THETA,PHI,ETHETA,EPHI)
      ELSE
C ------------ Find unit vectors for pattern direction
      CALL FFDIRC(THETA,PHI,VR,VT,VP)
C ------------ Express VR in element coordinates for pattern
C              directions & Express VT and VP in element coordinates
      CALL PATROT(ROT,VR,VT,VP,THETE,PHE,VTP,VPP)
C ------------ Find pattern
      TH=THETE/TR
      PH=PHE/TR
      CALL PATIND(INST,TH,PH,ETHETE,EPHE)
C ------------ Find unit vectors in element coordinate system
      CALL FFDIRC(THETE,PHE,VRR,VTR,VPR)
C ------------ Project element components onto re-expressed
C              unit vectors to find components
      ETHETA=ETHETE*DOT(VTR,VTP)+EPHE*DOT(VPR,VTP)
      EPHI=ETHETE*DOT(VTR,VPP)+EPHE*DOT(VPR,VPP)
      ENDIF
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
