      COMPLEX FUNCTION SCUTAL(RL1,RL2,F,X,Y,NINT,POL)
C
C  Mutual admittance between two square patch antennas
C  Using currents in common for first patch
C
C  RL1     Resonant length of 1st patch (cm)
C  RL2     Resonant length of 2nd patch (cm)
C  F       Frequency (GHz)
C  X,Y     Position of 2nd patch (cm)
C  NINT    Points in integral along edges
C  POL     Polarization: 0 Linear, -1 RHC, +1 LHC
C
C  Note:   Feeds located on X axis
C
      COMPLEX CCDOT,EFIELD(3),HFIELD(3),AM(3),SS
      DIMENSION XF(3),XC(3),XB(1)
      EXTERNAL BLOCKN
      DATA CC/.2997925/,XC/0.,0.,0./
      WID1=RL1*.01
      WID2=RL2*.01
      WAVEL=CC/F
      HP=WID2/NINT
      V1=SQRT(1./RRADCN(WID1/WAVEL))
C ------------------- Loop on edges of second patch
      SS=0.
      DO 1 IEDGE=1,4
C ------------------- Find reaction along edge
      DO 1 I=1,NINT
      POS=HP*(I-.5)
      CALL RPPERM(POS,WID2,WID2,XF,AM,IEDGE,POL)
      XF(1)=XF(1)+X*.01
      XF(2)=XF(2)+Y*.01
C ------------------- Find fields at point due to 1st patch
      CALL NFPATR(XC,BLOCKN,XB,XF,EFIELD,HFIELD)
C ------------------- Find reaction at point
    1 SS=CCDOT(HFIELD,AM)*HP+SS
C ------------------- Half space radiation, reduce by 1/2
      SCUTAL=-SS/V1/2.
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
