      SUBROUTINE SPHGEO(RADIUS,ALINC,LUNIT,NEMI)
C
C  Geometry portion of sphere in currents file
C
C  RADIUS  Radius of sphere (m)
C  ALINC   Length increment of patches
C  LUNIT   Logical unit of random access file for currents
C  NEMI    1 Upper hemisphere only, 2 Sphere
C
      DIMENSION FREC(19),SP(3)
      INTEGER*4 IBUF(19)
      DATA PI/3.141592654/
      SP(1)=1.
      NT=RADIUS*PI/ALINC/2.+.1
      DELT=PI/NT/2.
      L=1
C ------------ Loop on hemisphere
      DO 3 N=1,NEMI
      SCON=(N-1)*PI/2.
C ------------ Loop on Theta
      DO 2 I=1,NT
      SP(2)=DELT*(I-.5)+SCON
      DL=ABS(COS(SP(2)-.5*DELT)-COS(SP(2)+.5*DELT))*RADIUS
C ------------ Loop on Phi
      NP=2.*PI*SIN(SP(2))*RADIUS/ALINC+1.
      DELP=2.*PI/NP
      DO 2 J=1,NP
      SP(3)=DELP*(J-1)
C ------------ Differential area
      FREC(4)=DL*DELP*RADIUS
C ------------ Unit normal
      CALL ARADS(SP,FREC(5))
      DO 1 K=1,3
    1 FREC(K)=RADIUS*FREC(K+4)
      L=L+1
    2 WRITE(LUNIT,REC=L)(FREC(NN),NN=1,19)
    3 CONTINUE
      IBUF(1)=L-1
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
