      SUBROUTINE VDICMG(FREQ,FD,AL,POLR,UU,UL,NPTS,CURR,IMAGE,LUNIT,ZIN)
C
C  Current multiplier for Vee dipole and Input Impedance
C
C  FREQ    Frequency (GHz)
C  FD(3)   Feed point (m) (height = FD(3))
C  AL      Length of dipole (sum of both arms) (m)
C  POLR    Radius of rod of dipole
C  UU(3)   Direction of unit vector of upper arm
C  UL(3)   Direction of unit vector of lower arm
C  NPTS    Number of points along each arm
C  CURR    Multiplier on current magnitude (for mutual = 1)
C  IMAGE   0 - dipole alone, 1 - dipole over ground plane
C  LUNIT   Logical unit of file for currents
C
      COMPLEX ZIN,Z12
      DIMENSION FD(3),UU(3),UL(3),UUI(3),ULI(3),FDI(3)
      DATA CC/.2997925/,PI/3.14159265/
C ------------- Find currents on single dipole
      IMAGG=0
      CURR=1.
      CALL VDICUR(FREQ,FD,AL,UU,UL,NPTS,CURR,IMAGG,LUNIT)
C ------------- Load into currents common
      CALL CURCOM(LUNIT)
      FDI(1)=FD(1)
      FDI(2)=FD(2)+POLR
      FDI(3)=FD(3)
C ------------- Find self impedance
      CALL VDIMUC(FDI,AL,ALC,UU,UL,NPTS,ZIN)
      IF(IMAGE.EQ.1)THEN
      DO 1 I=1,2
      FDI(I)=FD(I)
      UUI(I)=UU(I)
    1 ULI(I)=UL(I)
      FDI(3)=-FD(3)
      UUI(3)=-UU(3)
      ULI(3)=-UL(3)
C -------------  Find mutual impedance with image
      CALL VDIMUC(FDI,AL,ALC,UUI,ULI,NPTS,Z12)
      ZIN=ZIN-Z12
      ENDIF
      CURR=1./(SQRT(REAL(ZIN))*SIN(PI*AL*FREQ/CC))
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
C
C  Note fewer currents are needed for pattern calculations than for the
C  self impedance.  The currents file can be reinitialized VDICUR with
C  fewer points but with CURR from this routine to normalize power to
C  1 watt.
C
      END
