      PROGRAM VDICOC
C
C  Mutual Coupling between Vee dipoles over ground using Dyadic
C  Green's Function approach
C
C  Written   16 Jul 94
C  Last Edit 25 Mar 96
C
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
C
      DIMENSION DIST(301),COUP(301),YR(301),YI(301),UU(3),UL(3),
     1 FD1(3),FD2(3),UF(4)
      CHARACTER UN(4)*4
      COMPLEX Z(4),ZS,ZL,ZIN,CURJA,CURMA
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,2000)
      COMMON /CURRENJ/CURJA(3,2000)
      COMMON /CURRENM/CURMA(3,2000)
      DATA TR/.01745329/,C/.2997925/
     1,UN/' in.',' ft.',' cm ',' m. '/,UF/.0254,.3048,.01,1./
      OPEN(19,FILE='vdicoc.cur',ACCESS='DIRECT',RECL=76)
      WRITE(6,1)
    1 FORMAT(' Mutual coupling between identical Vee Dipoles',/,
     1' Enter Resonant length ',$)
      READ(5,*)RL
      WRITE(6,2)
    2 FORMAT(' Enter units: 1 in., 2 ft., 3 cm, 4 m ',$)
      READ(5,*)IUN
      WRITE(6,3)
    3 FORMAT(' Enter element diameter ',$)
      READ(5,*)DIA
      POLR=DIA*UF(IUN)*.5
      WRITE(6,4)
    4 FORMAT(' Enter element tilt ',$)
      READ(5,*)TILT
      WRITE(6,5)
    5 FORMAT(' Enter frequency (GHz) ',$)
      READ(5,*)FREQ
      WAVE=C/FREQ
      OPEN(66,FILE='vdicoc.out')
      TILT=TILT*TR
      UL(2)=0.
      UU(2)=0.
      UL(1)=-COS(TILT)
      UU(1)=COS(TILT)
      UL(3)=-SIN(TILT)
      UU(3)=-SIN(TILT)
      WRITE(66,6)RL,UN(IUN),DIA,FREQ,TILT/TR
    6 FORMAT(' Mutual coupling between identical Vee dipoles',/,
     1' Resonant Length:          ',F8.4,A4,/,
     2' Element diameter:         ',F8.4,/,
     3' Dipole tilt:              ',F8.2,/,
     4' Frequency (GHz):          ',F8.4)
      RL=RL*UF(IUN)
    7 WRITE(6,8)
    8 FORMAT(' E plane along X axis',/,' Enter Phi ',$)
      READ(5,*)PHI
      IF(PHI.LT.0.)STOP
      WRITE(6,9)
    9 FORMAT(' Enter points in self integrals ',$)
      READ(5,*)NINT
      WRITE(6,10)
   10 FORMAT(' Enter points in mutual integrals ',$)
      READ(5,*)NPTS
      WRITE(66,11)NINT,NPTS
   11 FORMAT(' Points in self integrals:  ',I3,
     1       ' Mutual integrals:          ',I3)
      WRITE(6,12)
   12 FORMAT(' Dipoles over ground plane? ',$)
      IGR=NYES(K)
      IF(IGR.EQ.1)IMAGE=1
      IF(IGR.NE.1)IMAGE=0
      FD2(1)=0.
      FD2(2)=0.
      FD1(1)=0.
      FD1(2)=0.
      FD1(3)=0.
      FD2(3)=0.
      IF(IGR.EQ.1)THEN
      WRITE(6,13)
   13 FORMAT(' Enter heights (1,2) ',$)
      READ(5,*)HEIT1,HEIT2
      WRITE(66,14)HEIT1,HEIT2
   14 FORMAT(' Dipoles over ground',/,
     1       ' Heights of elements: ',2F8.3)
      FD1(3)=HEIT1*UF(IUN)
      FD2(3)=HEIT2*UF(IUN)
      ENDIF
C  -------- Find self impedance of each dipole (over ground)
      CALL VDICMG(FREQ,FD1,RL,POLR,UU,UL,NINT,CUR,IMAGE,19,Z(1))
      CALL VDICMG(FREQ,FD2,RL,POLR,UU,UL,NINT,CUR,IMAGE,19,Z(4))
      ZS=CONJG(Z(1))
      ZL=CONJG(Z(4))
      CUR=1.
C  -------- Load currents of dipole 2 into file
      CALL VDICUR(FREQ,FD2,RL,UU,UL,NPTS,CUR,0,19)
C  -------- If over ground plane, add currents of image
      IF(IMAGE.EQ.1)CALL VDICUR(FREQ,FD2,RL,UU,UL,NPTS,CUR,IMAGE,19)
      CALL CURCOM(19)
      WRITE(66,15)Z(1),Z(4)
      WRITE(6,15)Z(1),Z(4)
   15 FORMAT(' Self impedance of dipole 1: ',2F8.2,/,
     1       ' Self impedance of dipole 2: ',2F8.2)
      ZS=CONJG(Z(1))
      ZL=CONJG(Z(4))
      WRITE(6,16)
   16 FORMAT(' Enter Center Separation Start,Stop,Step ',$)
      READ(5,*)R1,R2,R3
      IF(R3.EQ.0.)STOP
      NR=(R2-R1)/R3+1.3
      WRITE(6,17)
   17 FORMAT(' Center Separation: 1 dimensions, 2 wavelengths ',$)
      READ(5,*)IRR
      WRITE(6,18)
   18 FORMAT(' List? ',$)
      LIST=NYES(K)
      IF(LIST.EQ.1.AND.IRR.EQ.1)THEN
      WRITE(6,19)PHI
      WRITE(66,19)PHI
   19 FORMAT(' Angle of Radial Line = ',F7.2,/,
     1 ' Distances in cm.',/,
     2'   Radius   Coupling dB        Mutual Impedance ')
      ENDIF
      IF(LIST.EQ.1.AND.IRR.EQ.2)THEN
      WRITE(6,20)PHI
      WRITE(66,20)PHI
   20 FORMAT(' Angle of Radial Line = ',F7.2,/,
     1 ' Distances in wavelengths',/,
     2'   Radius   Coupling dB        Mutual Impedance ')
      ENDIF
   21 FORMAT(F9.3,F11.3,1PE14.3,E14.3)
      DO 22 I=1,NR
      DIST(I)=R1+FLOAT(I-1)*R3
      IF(IRR.EQ.1)RR=DIST(I)*UF(IUN)
      IF(IRR.EQ.2)RR=DIST(I)*WAVE
      FD1(1)=RR*COS(PHI*TR)
      FD1(2)=RR*SIN(PHI*TR)
      CALL VDIMUC(FD1,RL,RL,UU,UL,NPTS,Z(2))
      YR(I)=REAL(Z(2))
      YI(I)=AIMAG(Z(2))
      Z(3)=Z(2)
      CALL ZRES(Z,ZS,ZL,R,RA,T,TA,ZIN)
      COUP(I)=T
      IF(LIST.EQ.1)THEN
      WRITE(66,21)DIST(I),COUP(I),YR(I),YI(I)
      WRITE(6,21)DIST(I),COUP(I),YR(I),YI(I)
      ENDIF
   22 CONTINUE
      WRITE(6,23)
   23 FORMAT(' Any plots? ',$)
      IF(NYES(K).EQ.1)THEN
      WRITE(6,24)
   24 FORMAT(' Plot coupling? ',$)
      IF(NYES(K).EQ.1)CALL RCPLT(DIST,COUP,NR)
      WRITE(6,25)
   25 FORMAT(' Plot real part of normalized admittance? ',$)
      IF(NYES(K).EQ.1)CALL RCPLT(DIST,YR,NR)
      WRITE(6,26)
   26 FORMAT(' Plot imaginary part of normalized admittance? ',$)
      IF(NYES(K).EQ.1)CALL RCPLT(DIST,YI,NR)
      ENDIF
      GOTO 7
      END
