      SUBROUTINE VDIMUC(FD,AL,ALC,UU,UL,NPTT,Z12)
C
C  Mutual coupling between Vee Dipole and Currents File with dipole
C  (built in Simpson's rule integration)
C
C  FD(3)    Location of Vee Dipole
C  AL       Length of dipole (sum of arms) (m)
C  ALC      Length of dipole coupling to
C  UU(3)    Unit vector in direction of upper arm
C  UL(3)    Unit vector in direction of lower arm
C  NPTT	    Number of points
C  Z12      Mutual impedance
C
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,2000)
      COMPLEX SS,EFIELD(3),HFIELD(3),Z12,CURC(3),CCDOT
      DIMENSION FD(3),XC(3),XS(3),UU(3),UL(3),U(3),XB(1)
      EXTERNAL BLOCKN
      DATA XC/0.,0.,0./
      SS=0.
C --------- Round points up to odd for Simpson's rule
      NPTS=NPTT
      IF(MOD(NPTS,2).EQ.0)NPTS=NPTS+1
      ARI=AL/(2.*(NPTS-1))
C --------------- Loop on arms
      DO 3 K=1,2
      DO 1 I=1,3
      IF(K.EQ.2)U(I)=UU(I)
      IF(K.EQ.1)U(I)=UL(I)
      CURC(I)=U(I)
    1 CONTINUE
C --------------- Loop on arm
      DO 2 I=1,NPTS
      T=ARI*(I-1)
      CUR=SIN(PKC*(AL/2.-T))*(-1.)**K/3.
C ---------- Simpson's rule weights
      IF(I.GT.1.AND.I.LT.NPTS)THEN
      IF(MOD(I-1,2).EQ.1)CUR=CUR*4.
      IF(MOD(I-1,2).EQ.0)CUR=CUR*2.
      ENDIF
      CALL VLINC(1.,FD,T,U,XS)
      CALL NFPATR(XC,BLOCKN,XB,XS,EFIELD,HFIELD)
    2 SS=SS+CCDOT(EFIELD,CURC)*CUR*ARI
    3 CONTINUE
C --------------- Find magnitude of currents at inputs to dipoles
      CUR1=SIN(AL*PKC/2.)
      CUR2=SIN(ALC*PKC/2.)
      Z12=-SS/CUR1/CUR2
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
