      PROGRAM VDPATD
C
C  Green's function analysis of Vee Dipole over disk ground pattern
C
C  WRITTEN   09 Apr 95
C  LAST EDIT 28 May 96
C
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
C
      DIMENSION THT(361),AEI(361),VR(3),VT(3),VP(3),XF(3),UU(3),
     1 UL(3),XC(3),FD(3),VCC(3),ULY(3),UUY(3),UF(4),XB(3)
      COMPLEX EITH(361),EIPH(361),EII,EFIELD(3),HFIELD(3),CUR,ZIN,
     1 CURJA,CURMA,XCUR,YCUR
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,2000)
      COMMON /CURRENJ/CURJA(3,2000)
      COMMON /CURRENM/CURMA(3,2000)
      CHARACTER UN(4)*4
      EXTERNAL BLOCKN
      DATA TR/.01745329/,IC/0/,GCONS/.182637/,XC/0.,0.,0./
     1,UN/' in.',' ft.',' cm ',' m. '/,UF/.0254,.3048,.01,1./
      LU=66
      WRITE(6,1)
    1 FORMAT(' Green s function calc. of Vee dipole Pattern over disk',
     3/,' Line Printer Output? ',$)
      LPR=NYES(K)
      IF(LPR.EQ.1)OPEN(66,FILE='vdpatd.out')
      OPEN(19,FILE='vdpatd.dat',ACCESS='DIRECT',RECL=76)
      OPEN(20,FILE='vddisk.dat',ACCESS='DIRECT',RECL=76)
      WRITE(6,47)
   47 FORMAT(' Enter units: 1 in., 2 ft., 3 cm, 4 m ',$)
      READ(5,*)IUN
      WRITE(6,2)
    2 FORMAT(' Enter length, element diameter ',$)
      READ(5,*)ALENF,DIA
      POLR=DIA*UF(IUN)/2.
      WRITE(6,45)
   45 FORMAT(' Enter X-axis Amplitude (dB), Phase ',$)
      READ(5,*)AMPX,PHSX
      XCUR=10.**(AMPX/20.)*CMPLX(COS(PHSX*TR),SIN(PHSX*TR))
      WRITE(6,46)
   46 FORMAT(' Enter Y-axis Amplitude (dB), Phase ',$)
      READ(5,*)AMPY,PHSY
      YCUR=10.**(AMPY/20.)*CMPLX(COS(PHSY*TR),SIN(PHSY*TR))
      TOTAL=SQRT(CABS(XCUR)**2+CABS(YCUR)**2)
      XCUR=XCUR/TOTAL
      YCUR=YCUR/TOTAL
      WRITE(6,42)
   42 FORMAT(' Enter disk diameter ',$)
      READ(5,*)DDIA
      DDIAM=DDIA*UF(IUN)
      WRITE(6,43)
   43 FORMAT(' Enter patch increments ',$)
      READ(5,*)ALIN
      ALINC=ALIN*UF(IUN)
      WRITE(6,44)
   44 FORMAT(' Enter center of disk: X,Y ',$)
      READ(5,*)XCC,YCC
      VCC(1)=XCC*UF(IUN)
      VCC(2)=YCC*UF(IUN)
      VCC(3)=0.
      CALL PLCGEO(DDIAM,VCC,ALINC,20)
    3 WRITE(6,4)
    4 FORMAT(' Enter Frequency (GHz) ',$)
      READ(5,*)FREQ
      WRITE(6,41)
   41 FORMAT(' Enter ground plane height of dipole ',$)
      READ(5,*)HEIGHF
      WRITE(6,40)
   40 FORMAT(' Enter element tilt ',$)
      READ(5,*)TILT
      IF(LPR.EQ.1)WRITE(LU,5)ALENF,UN(IUN),DIA,HEIGHF,TILT,DDIA,ALIN,
     1 XCC,YCC,FREQ,AMPX,PHSX,AMPY,PHSY
    5 FORMAT(' Dipole length:        ',F8.3,A4,/,
     1       ' Dipole Diameter:      ',F8.4,/,
     1       ' Center height:        ',F8.3,/,
     2       ' Element tilt (deg):   ',F8.2,/,
     2       ' Disk diameter:        ',F8.2,/,
     3       ' Current patch incr:   ',F8.3,/,
     5       ' Disk center: (X,Y):   ',F8.3,2X,F8.3,/,
     1       ' Frequency (GHz):      ',F8.3,/,
     2       ' X axis amplitude dB:  ',F8.2,/,
     3       ' X axis phase:         ',F8.2,/,
     2       ' Y axis amplitude dB:  ',F8.2,/,
     3       ' Y axis phase:         ',F8.2)
      HEIGHT=HEIGHF*UF(IUN)
      ALEN=ALENF*UF(IUN)
      TILT=TILT*TR
      FD(1)=0.
      FD(2)=0.
      FD(3)=HEIGHT
      UL(2)=0.
      UU(2)=0.
      UL(1)=-COS(TILT)
      UU(1)=COS(TILT)
      UL(3)=-SIN(TILT)
      UU(3)=-SIN(TILT)
      ULY(1)=0.
      UUY(1)=0.
      ULY(2)=-COS(TILT)
      UUY(2)=COS(TILT)
      ULY(3)=-SIN(TILT)
      UUY(3)=-SIN(TILT)
      WRITE(6,33)
   33 FORMAT(' Enter points on pole for integrals imped, pattern ',$)
      READ(5,*)NPTZ,NPTS
      IMAGE=1
      CALL VDICMG(FREQ,FD,ALEN,POLR,UU,UL,NPTZ,CURR,IMAGE,19,ZIN)
      IMAGE=0
      CUR=XCUR*CURR
      CALL VDICUR(FREQ,FD,ALEN,UU,UL,NPTS,CUR,IMAGE,19)
      CUR=YCUR*CURR
      IMAGE=2
      CALL VDICUR(FREQ,FD,ALEN,UUY,ULY,NPTS,CUR,IMAGE,19)
      CALL CURCOM(19)
C  --------------- Find currents on ground plane
      CALL REFCUR(XC,BLOCKN,XB,20)
      CALL CURCAT(20)
    6 WRITE(6,7)
    7 FORMAT(' Enter: 1 Conic Cut, 2 Great Circle (Azimuth) ',$)
      READ(5,*)IPAT
      IF(IPAT.EQ.2)THEN
      WRITE(6,8)
    8 FORMAT(' Enter Theta Start,Stop,Step ',$)
      ELSE
      WRITE(6,9)
    9 FORMAT(' Enter Phi Start,Stop,Step ',$)
      ENDIF
      READ(5,*)T1,T2,TS
      NT=(T2-T1)/TS+1.4
      IF(NT.GT.361)STOP
      IF(IPAT.EQ.2)THEN
      WRITE(6,10)
   10 FORMAT(' Enter Constant Phi Angle ',$)
      ELSE
      WRITE(6,11)
   11 FORMAT(' Enter Constant Theta Angle ',$)
      ENDIF
      READ(5,*)AN
      WRITE(6,34)
   34 FORMAT(' Near field pattern? ',$)
      NEAR=NYES(K)
      IF(NEAR.EQ.1)THEN
      WRITE(6,35)
   35 FORMAT(' Enter radius ',$)
      READ(5,*)DIST
      WRITE(66,36)DIST
   36 FORMAT(' Near field pattern at Radius = ',F8.2)
      DIST=DIST*UF(IUN)
      ENDIF
      IF(IPAT.EQ.1)THETA=AN*TR
      IF(IPAT.EQ.2)PHI=AN*TR
      IF(IPAT.EQ.2.AND.LPR.EQ.1)WRITE(LU,12)AN
   12 FORMAT(/,' Constant Phi Angle: ',F7.2)
      IF(IPAT.EQ.1.AND.LPR.EQ.1)WRITE(LU,13)AN
   13 FORMAT(/,' Constant Theta Angle: ',F7.2)
C
C  CALCULATE PATTERN
C
      DO14I=1,NT
      THT(I)=T1+FLOAT(I-1)*TS
      IF(IPAT.EQ.2)THETA=THT(I)*TR
      IF(IPAT.EQ.1)PHI=THT(I)*TR
      IF(NEAR.EQ.1)THEN
      CALL FFDIRC(THETA,PHI,VR,VT,VP)
      DO37J=1,3
   37 XF(J)=VR(J)*DIST
      CALL NFPATR(XC,BLOCKN,XB,XF,EFIELD,HFIELD)
      EITH(I)=0.
      EIPH(I)=0.
      DO38J=1,3
      EITH(I)=DIST*EFIELD(J)*VT(J)*GCONS+EITH(I)
   38 EIPH(I)=DIST*EFIELD(J)*VP(J)*GCONS+EIPH(I)
      ELSE
      CALL FFPATR(XC,BLOCKN,XB,THETA,PHI,EITH(I),EIPH(I))
      EITH(I)=EITH(I)*GCONS
      EIPH(I)=EIPH(I)*GCONS
      ENDIF
   14 CONTINUE
      KPM=-1
   15 IF(IC.EQ.0)GOTO17
      WRITE(6,16)
   16 FORMAT(' Normalize to Last Plot Maximum? ',$)
      KPM=NYES(K)
   17 WRITE(6,18)
   18 FORMAT(' Enter Output Code:',/,4X,' 1 E Theta, 2 E Phi'
     1,' 3 RHC, 4 LHC, 5 Max. Lin., 6 Min. Lin.,'
     2/,' 7 +45 Comp., 8 -45 Comp., 9 Power ',$)
      READ(5,*)IOUT
      AEX=-120.
      DO19I=1,NT
      CALL OUTCC(IOUT,EITH(I),EIPH(I),EII)
      CALL PMAGC(EII,AEI(I),PHS)
      IF(AEI(I).GT.AEX)THEN
      AEX=AEI(I)
      THX=THT(I)
      ELSE
      ENDIF
   19 CONTINUE
   20 IF(IC.EQ.0)EMAX=AEX
      IF(KPM.EQ.-1)EMAX=AEX
      IC=IC+1
      WRITE(6,21)
   21 FORMAT(' Plot 0 None, 1 Full Circle ',$)
      READ(5,*)IPLT
      IF(IPLT.EQ.1)CALL PPATP(T1,T2,TS,AEI,EMAX,IP)
   22 WRITE(6,23)
   23 FORMAT(' List? ',$)
      IF(NYES(K).EQ.1)THEN
      IF(IPAT.EQ.2.AND.LPR.EQ.1)WRITE(LU,27)
      IF(IPAT.EQ.1.AND.LPR.EQ.1)WRITE(LU,28)
      IF(IPAT.EQ.2)WRITE(6,27)
      IF(IPAT.EQ.1)WRITE(6,28)
      DO24I=1,NT
      THETA=T1+FLOAT(I-1)*TS
      CALL OUTCC(IOUT,EITH(I),EIPH(I),EII)
      CALL PMAGC(EII,AEX,PHS)
      WRITE(6,25)THETA,AEX,PHS
   24 IF(LPR.EQ.1)WRITE(LU,25)THETA,AEX,PHS
   25 FORMAT(F6.1,4X,F7.2,2X,F7.2)
   27 FORMAT(/,' Theta',2X,' Ampl(dB)',3X,' Phase',/)
   28 FORMAT(/,'  Phi ',2X,' Ampl(dB)',3X,' Phase',/)
      ELSE
      END IF
      WRITE(6,29)
   29 FORMAT(' Another Polarization? ',$)
      IF(NYES(K).EQ.1)GOTO15
      WRITE(6,30)
   30 FORMAT(' New Pattern Cut? ',$)
      IF(NYES(K).EQ.1)GOTO6
      WRITE(6,31)
   31 FORMAT(' New Frequency? ',$)
      IF(NYES(K).EQ.1)GOTO3
      END
      SUBROUTINE PLCGEO(DIA,VP,ALINC,LUNIT)
C
C  Geometry file of Round Disk for Currents File
C  Polar Grid
C
C  DIA     Diameter of disk
C  VP(3)   Location of center
C  Note:   Normal along Z-axis
C  ALINC   Length increment in aperture plane for current patches
C  LUNIT   Logical unit of random access file for currents
C
      DIMENSION VP(1),FREC(19),PP(3)
      INTEGER*4 IBUF(19)
      DATA PI/3.14159654/
      NR=DIA/ALINC/2.+.5
      HR=DIA/2./NR
      FREC(5)=0.
      FREC(6)=0.
      FREC(7)=1.
      KREC=1
C  ------------- Loop over radius
      DO 2 J=1,NR
      RAD=(FLOAT(J-1)+.5)*HR
C  ------------- Find differential area on aperture plane
      R1=RAD-HR/2.
      R2=RAD+HR/2.
      NP=2.*PI*RAD/ALINC+.5
      HP=2.*PI/NP
C  ------------- Area of wedge
      FREC(4)=(R2**2-R1**2)*HP/2.
C  ------------- Loop over Phi
      DO 1 I=1,NP
      PH=FLOAT(I-1)*HP
      PP(1)=RAD*COS(PH)
      PP(2)=RAD*SIN(PH)
      PP(3)=0.
C  ------------- Move to center of plate
      CALL VLINC(1.,VP,1.,PP,FREC)
      KREC=KREC+1
    1 WRITE(LUNIT,REC=KREC)(FREC(NN),NN=1,19)
    2 CONTINUE
      IBUF(1)=KREC-1
      IBUF(2)=1
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      RETURN
      END
      SUBROUTINE PMAGC(E,AMP,PHASE)
      COMPLEX E
      IF(CABS(E).GT.1.E-12)THEN
      AMP=20.*ALOG10(CABS(E))
      PHASE=ATAN2(AIMAG(E),REAL(E))/.01745329
      ELSE
      AMP=-240.
      PHASE=0
      ENDIF
      RETURN
      END
      SUBROUTINE OUTCC(IOUT,ET,EP,E)
C
C  CONVERTS THETA & PHI COMPONENTS (VOLTAGE) TO
C  AMPLITUDE DB AND PHASE DEG.
C
C  IOUT
C    1 E THETA (HORIZONTAL), 2 E PHI (VERTICAL), 3 RHC, 4 LHC,
C    5 MAX LINEAR, 6 MIN LINEAR
C  ET, EP COMPLEX THETA & PHI COMPONENTS (VOLTAGE)
C  E OUTPUT VOLTAGE
C
      COMPLEX ET,EP,E,F,CJ
      DATA S2/1.4142135/,CJ/(0.,1.)/
      GOTO(1,2,3,4,5,6,8,9,11),IOUT
    1 E=ET
      GOTO7
    2 E=EP
      GOTO7
    3 E=(ET+CJ*EP)/S2
      GOTO7
    4 E=(ET-CJ*EP)/S2
      GOTO7
    5 E=(ET+CJ*EP)/S2
      F=(ET-CJ*EP)/S2
      E=(CABS(E)+CABS(F))/S2
      GOTO7
    6 E=(ET+CJ*EP)/S2
      F=(ET-CJ*EP)/S2
      E=(CABS(E)-CABS(F))/S2
      GOTO7
    8 E=(ET+EP)/S2
      GOTO7
    9 E=(ET-EP)/S2
      GOTO7
   11 E= SQRT(CABS(ET)**2+CABS(EP)**2)
      GOTO7
    7 RETURN
      END
