      SUBROUTINE VGRHJF(VR,VT,VP,XS,PK,CUR,HTHETA,HPHI)
C
C  Far field Vector Green's Function
C
C  Vector Green's function between source current density: J
C  and magnetic field: H  or
C  Vector Green's function between source current magnetic density: M
C  and the electric field: E when multiplied by -1
C
C  VR(3)    Radial unit vector
C  VT(3)    Theta directed unit vector
C  VP(3)    Phi directed unit vector
C  XS(3)    Position of current element
C  PK       Propagation constant = 2*Pi/wavelength
C  CUR(3)   Rectangular coordinates of current density (complex)
C
C  HTHETA   Theta component of magnetic (electric) field
C  HPHI     Phi component of magnetic (electric) field
C
      DIMENSION VR(3),VT(3),VP(3),XS(3)
      COMPLEX CUR(3),CONP,HTHETA,HPHI
      DATA FPI/12.5663706/
      PHASE=PK*DOT(XS,VR)
      CONP=-CMPLX(0.,PK)*CMPLX(COS(PHASE),SIN(PHASE))/FPI
C ---------------- Field components from currents
      HTHETA=(CUR(1)*VP(1)+CUR(2)*VP(2)+CUR(3)*VP(3))*CONP
      HPHI=-(CUR(1)*VT(1)+CUR(2)*VT(2)+CUR(3)*VT(3))*CONP
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
