      SUBROUTINE VSLCMG(FREQ,FD,AL,WIDL,UU,UL,NPTS,CURR,ICAV,LUNIT,YIN)
C
C  Current multiplier for Vee slot and Input Admittance
C
C  FREQ    Frequency (GHz)
C  FD(3)   Feed point (m)
C  AL      Length of slot (sum of both arms) (m)
C  WIDL    Width of slot
C  UU(3)   Direction of unit vector of upper arm
C  UL(3)   Direction of unit vector of lower arm
C  NPTS    Number of points along each arm
C  CURR    Multiplier on current magnitude (for mutual = 1)
C  ICAV    0 - Radiates on both sides, 1 Cavity behind
C  LUNIT   Logical unit of file for currents
C
      COMPLEX YIN
      DIMENSION FD(3),UU(3),UL(3),FDI(3)
      DATA CC/.2997925/,PI/3.14159265/
C ------------- Find currents on single slot
      CURR=1.
      ALC=AL
      CALL VSLCUR(FREQ,FD,AL,UU,UL,NPTS,CURR,LUNIT)
C ------------- Load into currents common
      CALL CURCOM(LUNIT)
      FDI(1)=FD(1)
      FDI(2)=FD(2)+WIDL
      FDI(3)=FD(3)
C ------------- Find self impedance
      CALL VSLMUC(FDI,AL,ALC,UU,UL,NPTS,YIN)
      CURR=1./SQRT(REAL(YIN)*SIN(PI*AL*FREQ/CC))
      IF(ICAV.EQ.1)THEN
      YIN=YIN/2.
      CURR=CURR*2.
      ENDIF
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
C
C  Note fewer currents are needed for pattern calculations than for the
C  self impedance.  The currents file can be reinitialized VSLCUR with
C  fewer points but with CURR from this routine to normalize power to
C  1 watt.
C
      END
