      SUBROUTINE ZRES(Z,ZS,ZL,R,RA,TRANS,TA,ZIN)
C
C  Response of Z matrix
C
C  Z(4)    2 x 2 Z matrix
C  ZS, ZL  Source, Load impedances
C  R	   Reflection coefficient magnitude
C  RA	   Reflection coefficient phase (deg)
C  TRANS   Transmission dB
C  TA	   Transmission phase (deg)
C  ZIN	   Input impedance
C
      COMPLEX Z(4),ZS,ZL,ZIN,B1
      ZIN=Z(1)-Z(2)*Z(3)/(ZL+Z(4))
      B1=(ZIN-ZS)/(ZIN+ZS)
      R=CABS(B1)
      RA=57.29578*ATAN2(AIMAG(B1),REAL(B1))
      B1=ZL*Z(3)/((Z(1)+ZS)*(Z(4)+ZL)-Z(2)*Z(3))
      TA=57.29578*ATAN2(AIMAG(B1),REAL(B1))
      TRANS=10.*ALOG10(4.*REAL(ZS)*REAL(ZL)*CABS(B1/ZL)**2)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
