function R21=m01fun1(r1,J1,r2,J2,k)
% function file to find the reaction between two current 
% distributons 
%
%    parameter			description
%
%	r1		position vectors, first current distribution samples
%	J1		first distribution currents
%	r2		position vectors, second current distribution samples
%	J1		second distribution currents
%	k		wavenumber
%


Z0=376.7;

[Na1 dum]=size(r1);	% number of samples, distribution 1
[Na2 dum]=size(r2);	% number of samples, distribution 2

E21=zeros(Na1,3);

for na=1:Na2	% iterate over v-dipole 2 samples

  E21c=k*Z0*prop02(r2(na,:),J2(na,:),r1,k); % field of 2 on 1

  E21=E21+E21c;	% total field on 1
 
end

R21=sum(dot01(E21,J1));


%