% MATLAB script file for calculating far-field
% patterns of open-ended TE10 rectangular wavequide
% 
% PART a: define variables
%

lam=1;			% wavelength
k0=2*pi/lam;		% wavenumber
Z0=376.7;		% free-space characteristic impedance

r0=[0 0 0];		% aperture center position vector
un0=[0 0 1];		% unit normal of aperture
ut2=[0 1 0];		% unit vector in narrow wall dimension
ut1=cross01(ut2,un0);	% unit vector in broad wall dimension

wx=lam;		% waveguide broad (a) dimension
wy=wx/2;		% narrow (b)dimension

dxm=lam/10;	% broad dimension maximum sampling spacing
dym=lam/10;	% narrow wall maximum sampling spacing

thd1=-90;	% theta cut start angle, deg
thd2=90;		% theta stop angle, deg
Nth=361;		% number of theta angles
phd=90;		% phi angle for theta cut

%