% MATLAB script file for calculating far-field 
% patterns of conical corrugated horn
% 
% PART a: define variables
%

lam=1;			% wavelength
k0=2*pi/lam;		% wavenumber
Z0=376.7;		% free-space characteristic impedance

r0=[0 0 0];		% aperture center position vector

un0=[0 0 1];		% unit normal of aperture
ut2=[0 1 0];		% unit vector in aperture y dimension
ut1=cross01(ut2,un0);	% in apertue x dimension

Da=3*lam;	% aperture diameter, inches
thfd=60;	% conical flare angle, deg

Xs=1e30;	% corrugation reactance

nph=1;		% phi mode number
krh1=0;		% start value, search for rho wavenumber
krh2=5;		% stop value, search for rho wavenumber
Nkrh=1000;	% number of rho wavenumber steps 

Ap=1/sqrt(2);		% sine mode
Bp=-i/sqrt(2);		% cosine mode

Ap=0
Bp=1

dphm=.25*lam;	% maximum phi sampling spacing
drm=.25*lam;	% maximum r sampling spacing

thd1=-180;	% theta cut start angle, deg
thd2=180;	% theta stop angle, deg
Nth=181;	% number of theta angles
phd=0;		% phi angle for theta cut


I13=ones(1,3); % 1 by 3 array of ones

%