% MATLAB script file for calculating far-field 
% patterns of vector electric point source on circular 
% perfectly-absorbing groundplane
%
% PART e: re-radiated patterns
% previous m-files: po10a, po10b, po10c, po10d
%

nth=(1:Nth)';	% Nth by 1 theta angle index array
dthd=(thd2-thd1)/(Nth-1);	% theta increment, deg
thd=thd1+(nth-1)*dthd;	% Nth by 1 array,theta angles
thr=pi/180*thd;		% in radians

EM=[];
HJ=[];

for nnth=1:Nthg:Nth % break up thd into smaller arrays
  [nnth Nth]

  thrs=thr(nnth:min([nnth+Nthg-1,Nth])); 

  phr=phrp*ones(size(thrs));	% phi angles, rad

  EMs=propff01(req,Mn,thrs,phr,k0);	
			% FF electric field from Mn
  HJs=-propff01(req,Jn,thrs,phr,k0);
			% FF magnetic field from Jn
  EM=[EM;EMs];	% cascade thd arrays
  HJ=[HJ;HJs];	

end

Pth=abs(4*pi/2/Z0*(EM(:,1)+HJ(:,2)*Z0).^2);
Pph=abs(4*pi/2/Z0*(EM(:,2)-HJ(:,1)*Z0).^2);
PthdB=10*log10(Pth);
PphdB=10*log10(Pph);

%