% MATLAB script file for calculating far-field 
% patterns of vector electric point source on circular 
% impedance groundplane
%
% PART a: input parameters
%

fg=6;		% frequency, GHz
lam=11.803/fg;	% wavelength
k0=2*pi/lam;	% wavenumber
Z0=376.7;	% free-space characteristic impedance

rs=[0 0 lam/4];		% source position vector
J0=lam*sqrt(3/Z0/pi);	% electric source current 
Jr=[0 1 0];		% source orientation

er=1;		% coating relative real permittivity
LTe=.001;	% electric loss tangent
mr=1;		% cioating magnetic real permeability
LTm=0;		% magnetic lss tangent 
hc=lam*3/16/sqrt(er);	% coating thickness


Req=12;	% radius of groundplane
dthsmax=.5*lam;% max eq surface sampling interval, theta 
dphsmax=.5*lam;% max eq surface sampling interval, phi 

thd1=0; 	% pattern start angle, deg
thd2=180;	% pattern stop angle, deg
Nth=191;	% number of theta pattern angles
Nthg=1;	% number of theta angle subarrays
phdp=0;		% phi angle of theta pattern
phrp=pi/180*phdp;

%