% MATLAB script file for calculating far-field 
% patterns of reflector
% 
% PART e: re-radiated patterns
% previous m-files: po13a, po13b, po13c, po13d
%

nth=(1:Nth)';	% Nth by 1 theta angle index array
dthd=(thd2-thd1)/(Nth-1);	% theta increment, deg
thd=thd1+(nth-1)*dthd;	% Nth by 1 array,theta angles
thr=pi/180*thd;		% in radians

EM=[];
HJ=[];

for nnth=1:Nthg:Nth % break up thd into smaller arrays
  [nnth Nth]

  thrs=thr(nnth:min([nnth+Nthg-1,Nth])); % theta angles, rad
  phr=pi/180*phd*ones(size(thrs));	 % phi angles, rad

  EMs=propff01(rr,Mrr,thrs,phr,k0);	
			% FF electric field from Mn
  HJs=-propff01(rr,Jrr,thrs,phr,k0);
			% FF magnetic field from Jn
  EM=[EM;EMs];		% cascade thd arrays
  HJ=[HJ;HJs];	

end

Eth=EM(:,1)+HJ(:,2)*Z0;		% theta pol E field
Eph=EM(:,2)-HJ(:,1)*Z0; 	% phi pol E field
Er=sqrt(.5)*(Eth+i*Eph);	% RHCP E field
El=sqrt(.5)*(Eth-i*Eph);	% LHCP E field

Pth=abs(4*pi/2/Z0*Eth.^2);
Pph=abs(4*pi/2/Z0*Eph.^2);
Pr=abs(4*pi/2/Z0*Er.^2);
Pl=abs(4*pi/2/Z0*El.^2);

PthdB=10*log10(Pth);
PphdB=10*log10(Pph);
PrdB=10*log10(Pr);
PldB=10*log10(Pl);


%