% MATLAB script file for calculating far-field 
% spillover patterns of reflector 
% PART d: add patterns of spillover currents to feed patterns 
% previous m-files: po14a, po14b, po14c
%

nth=(1:Nth)';	% Nth by 1 theta angle index array
dthd=(thd2-thd1)/(Nth-1);	% theta increment, deg
thd=thd1+(nth-1)*dthd;	% Nth by 1 array,theta angles
thr=pi/180*thd;		% in radians

EMb=[];
HJb=[];

for nnth=1:Nthg:Nth % break up thd into smaller arrays
  [nnth Nth]

  thrs=thr(nnth:min([nnth+Nthg-1,Nth])); % theta angles, rad
  phr=pi/180*phd*ones(size(thrs));	 % phi angles, rad
  EMs=propff01(rr,Mrs,thrs,phr,k0);	
			% FF electric field from Mn
  HJs=-propff01(rr,Jrs,thrs,phr,k0);
			% FF magnetic field from Jn
  EMb=[EMb;EMs];	% cascade thd arrays
  HJb=[HJb;HJs];	

end


%____blockage patterns

Ethb=EMb(:,1)+HJb(:,2)*Z0;	% theta pol E field
Ephb=EMb(:,2)-HJb(:,1)*Z0; 	% phi pol E field
Erb=sqrt(.5)*(Ethb+i*Ephb);	% RHCP E field
Elb=sqrt(.5)*(Ethb-i*Ephb);	% RHCP E field

Pthb=abs(4*pi/2/Z0*Ethb.^2);
Pphb=abs(4*pi/2/Z0*Ephb.^2);
Prb=abs(4*pi/2/Z0*Erb.^2);
Plb=abs(4*pi/2/Z0*Elb.^2);

PthbdB=10*log10(Pthb);
PphbdB=10*log10(Pphb);
PrbdB=10*log10(Prb);
PlbdB=10*log10(Plb);


%____add to feed patterns

Ethr=EthF+Ethb;	% theta pol E field
Ephr=EphF+Ephb;	% phi pol E field
Err=ErF+Erb;	% RHCP pol E field
Elr=ElF+Elb;	% LHCP pol E field
 
Pthr=abs(4*pi/2/Z0*Ethr.^2);
Pphr=abs(4*pi/2/Z0*Ephr.^2);
Prr=abs(4*pi/2/Z0*Err.^2);
Plr=abs(4*pi/2/Z0*Elr.^2);

PthrdB=10*log10(Pthr);
PphrdB=10*log10(Pphr);
PrrdB=10*log10(Prr);
PlrdB=10*log10(Plr);


%____include reflector forward patterns

Etht=Ethd+Ethr;	% total fields
Epht=Ephd+Ephr;
Ert=Erd+Err;	% total fields
Elt=Eld+Elr;

Ptht=abs(4*pi/2/Z0*Etht.^2);
Ppht=abs(4*pi/2/Z0*Epht.^2);
Prt=abs(4*pi/2/Z0*Ert.^2);
Plt=abs(4*pi/2/Z0*Elt.^2);

PthtdB=10*log10(Ptht);
PphtdB=10*log10(Ppht);
PrtdB=10*log10(Prt);
PltdB=10*log10(Plt);

%