% MATLAB script file for calculating far-field 
% patterns of reflector
% 
% PART e: currents on feed blockage disk and struts
%

Hsb=[];
Esb=[];

for nb=1:Nb;		% iterate over blockage sample

  if(nb/10==ceil(nb/10));[nb Nb],end

  ut=norm01(ones(Nr,1)*rb(nb,:)-rr); 
		% unit vector ,reflector to blockage
  HscJ=-propnf01(rr,Jrr,rb(nb,:),k0); 	% H from J
  EscM=propnf01(rr,Mrr,rb(nb,:),k0); 	% E from M
  EscJ=-Z0*cross01(ut(nb,:),HscJ);	% source E field
  HscM=1/Z0*cross01(ut(nb,:),EscM);	% source E field

  Hsb=[Hsb;HscJ+HscM];	% sum contributions
  Esb=[Esb;EscM+EscJ];

end

Jrb=cross01(unb,Hsb);		% J from H 
Mrb=-cross01(unb,Esb);		% M from E 

Jnb=Jrb.*(DS*ones(1,3)); 	% normalized
Mnb=Mrb.*(DS*ones(1,3));	% normalized 

Mrbr=-Mnb;		% cancellation currents
Jrbr=-Jnb;

%