% MATLAB script file for calculating far-field 
% patterns of Cassegrain reflector 
%
% PART e: main reflector, currents
%

po13c	% reflector geometry

Hs=zeros(Nr,3);	% initialize memory for arrays
Es=Hs;

for ne=1:Ne;		% iterate over source sample

  if(ne/50==ceil(ne/50));[ne Ne],end

  ut=norm01(rr-ones(Nr,1)*res(ne,:)); 
			% unit vect, source to field

  HscJ=-propnf01(res(ne,:),Jrre(ne,:),rr,k0); % source H field
  EscJ=-Z0*cross01(ut,HscJ);	% source E field
  EscM=propnf01(res(ne,:),Mrre(ne,:),rr,k0); % source E field
  HscM=1/Z0*cross01(ut,EscM);	% source E field

  Hs=Hs+HscJ+HscM;	% sum contributions
  Es=Es+EscJ+EscM;

end

Jr=cross01(unr,Hs);		% eq electric current 
Mr=-cross01(unr,Es);		% eq magnetic current
Mn=Mr.*(dSr*ones(1,3));		% normalized current
Jn=Jr.*(dSr*ones(1,3)); 	% normalized current

Mrr=Mn;		% reradiation currents
Jrr=-Jn;

%