% MATLAB script file for calculating monostatic RCS of Truncated
% Right-Circular Cone
%
% Incidence is along the z axis from +infinity.
% 
% PART a: define variables
%

fg=.3;		% frequency, GHz
lam=11.803/fg;	% wavelength
k0=2*pi/lam;	% wavenumber
Z0=376.7;	% free-space characteristic impedance

%____cone geometry

% Rc2=5;		% top radius
Rc2=.5/.0254/2;		% top radius
% Lcc=50;		% length
Lcc=2.5/.0254;		% length
% Rc1=12;	% base radius
Rc1=Rc2+.001;	% base radius

dc1max=.05*lam;	% max sampling increment, base
dc2max=.05*lam;	% max sampling increment, top
dczmax=.05*lam;	% max sampling increment, cone


%____monostatic RCS angles

thd1=.0001;		% theta cut start angle, deg
thd2=180;	% theta stop angle, deg
Nth=80;	% number of theta angles
phd=0;		% phi angle for theta cut

Vin=[1 0];	% incident polarization
		% [theta phi] components


I13=ones(1,3); % 1 by 3 array of ones

%